/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Subtarget Enumeration Source Fragment                                      *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/


#ifdef GET_SUBTARGETINFO_ENUM
#undef GET_SUBTARGETINFO_ENUM

namespace llvm {
namespace GenX {
enum {
  DumpRegAlloc = 0,
  FeatureFP64 = 1,
  FeatureHWTIDFromPredef = 2,
  FeatureInstrAdd64 = 3,
  FeatureInstrBitRotate = 4,
  FeatureIntDivRem32 = 5,
  FeatureLongLong = 6,
  FeatureLongLongEmulation = 7,
  FeatureNoJmpi = 8,
  FeatureNoJumpTables = 9,
  FeatureSwitchjmp = 10,
  FeatureUseMulDDQ = 11,
  FeatureVectorDecomp = 12,
  FeatureWAFusedEUNoMask = 13,
  OCLRuntime = 14,
  WarnCallable = 15,
  NumSubtargetFeatures = 16
};
} // end namespace GenX
} // end namespace llvm

#endif // GET_SUBTARGETINFO_ENUM


#ifdef GET_SUBTARGETINFO_MC_DESC
#undef GET_SUBTARGETINFO_MC_DESC

namespace llvm {
// Sorted (by key) array of values for CPU features.
extern const llvm::SubtargetFeatureKV GenXFeatureKV[] = {
  { "add64", "enable support for native add64 intruction", GenX::FeatureInstrAdd64, { { { 0x0ULL, 0x0ULL, 0x0ULL, } } } },
  { "bitrotate", "support of rol/ror instructions", GenX::FeatureInstrBitRotate, { { { 0x0ULL, 0x0ULL, 0x0ULL, } } } },
  { "disable_jmpi", "disable jmpi", GenX::FeatureNoJmpi, { { { 0x0ULL, 0x0ULL, 0x0ULL, } } } },
  { "disable_jump_tables", "disable switch to jump tables lowering", GenX::FeatureNoJumpTables, { { { 0x0ULL, 0x0ULL, 0x0ULL, } } } },
  { "disable_vec_decomp", "disable vector decomposition pass", GenX::FeatureVectorDecomp, { { { 0x0ULL, 0x0ULL, 0x0ULL, } } } },
  { "divrem32", "supports 32-bit integer division", GenX::FeatureIntDivRem32, { { { 0x0ULL, 0x0ULL, 0x0ULL, } } } },
  { "dump_regalloc", "dump regalloc information", GenX::DumpRegAlloc, { { { 0x0ULL, 0x0ULL, 0x0ULL, } } } },
  { "emulate_i64", "emulate 64-bit operations", GenX::FeatureLongLongEmulation, { { { 0x0ULL, 0x0ULL, 0x0ULL, } } } },
  { "fp64", "support for double types", GenX::FeatureFP64, { { { 0x0ULL, 0x0ULL, 0x0ULL, } } } },
  { "hwtidfrompredef", "hwtid is obtained from predefined variable", GenX::FeatureHWTIDFromPredef, { { { 0x0ULL, 0x0ULL, 0x0ULL, } } } },
  { "longlong", "supports long long", GenX::FeatureLongLong, { { { 0x0ULL, 0x0ULL, 0x0ULL, } } } },
  { "mul_ddq", "use native support for mul [U]Dx[U]D->Q", GenX::FeatureUseMulDDQ, { { { 0x0ULL, 0x0ULL, 0x0ULL, } } } },
  { "ocl_runtime", "Prepare structures for OCL runtime", GenX::OCLRuntime, { { { 0x0ULL, 0x0ULL, 0x0ULL, } } } },
  { "switchjmp", "supports switchjmp visa instruction", GenX::FeatureSwitchjmp, { { { 0x0ULL, 0x0ULL, 0x0ULL, } } } },
  { "wa_nomask_fusedEU", "needs workaround for nomask operations under divergent control-flow", GenX::FeatureWAFusedEUNoMask, { { { 0x0ULL, 0x0ULL, 0x0ULL, } } } },
  { "warn_callable", "warn instead of error on callable violation", GenX::WarnCallable, { { { 0x0ULL, 0x0ULL, 0x0ULL, } } } },
};

#ifdef DBGFIELD
#error "<target>GenSubtargetInfo.inc requires a DBGFIELD macro"
#endif
#if !defined(NDEBUG) || defined(LLVM_ENABLE_DUMP)
#define DBGFIELD(x) x,
#else
#define DBGFIELD(x)
#endif

// ===============================================================
// Data tables for the new per-operand machine model.

// {ProcResourceIdx, Cycles}
extern const llvm::MCWriteProcResEntry GenXWriteProcResTable[] = {
  { 0,  0}, // Invalid
}; // GenXWriteProcResTable

// {Cycles, WriteResourceID}
extern const llvm::MCWriteLatencyEntry GenXWriteLatencyTable[] = {
  { 0,  0}, // Invalid
}; // GenXWriteLatencyTable

// {UseIdx, WriteResourceID, Cycles}
extern const llvm::MCReadAdvanceEntry GenXReadAdvanceTable[] = {
  {0,  0,  0}, // Invalid
}; // GenXReadAdvanceTable

#undef DBGFIELD

static const llvm::MCSchedModel NoSchedModel = {
  MCSchedModel::DefaultIssueWidth,
  MCSchedModel::DefaultMicroOpBufferSize,
  MCSchedModel::DefaultLoopMicroOpBufferSize,
  MCSchedModel::DefaultLoadLatency,
  MCSchedModel::DefaultHighLatency,
  MCSchedModel::DefaultMispredictPenalty,
  false, // PostRAScheduler
  false, // CompleteModel
  0, // Processor ID
  nullptr, nullptr, 0, 0, // No instruction-level machine model.
  nullptr, // No Itinerary
  nullptr // No extra processor descriptor
};

// Sorted (by key) array of values for CPU subtype.
extern const llvm::SubtargetSubTypeKV GenXSubTypeKV[] = {
 { "BDW", { { { 0x46eULL, 0x0ULL, 0x0ULL, } } }, &NoSchedModel },
 { "BXT", { { { 0xc6eULL, 0x0ULL, 0x0ULL, } } }, &NoSchedModel },
 { "CHV", { { { 0x46eULL, 0x0ULL, 0x0ULL, } } }, &NoSchedModel },
 { "CNL", { { { 0xc6eULL, 0x0ULL, 0x0ULL, } } }, &NoSchedModel },
 { "DG1", { { { 0x20b4ULL, 0x0ULL, 0x0ULL, } } }, &NoSchedModel },
 { "GLK", { { { 0xc6eULL, 0x0ULL, 0x0ULL, } } }, &NoSchedModel },
 { "HSW", { { { 0x4a4ULL, 0x0ULL, 0x0ULL, } } }, &NoSchedModel },
 { "ICL", { { { 0xc6eULL, 0x0ULL, 0x0ULL, } } }, &NoSchedModel },
 { "ICLLP", { { { 0x4b4ULL, 0x0ULL, 0x0ULL, } } }, &NoSchedModel },
 { "KBL", { { { 0xc6eULL, 0x0ULL, 0x0ULL, } } }, &NoSchedModel },
 { "SKL", { { { 0xc6eULL, 0x0ULL, 0x0ULL, } } }, &NoSchedModel },
 { "TGLLP", { { { 0x20b4ULL, 0x0ULL, 0x0ULL, } } }, &NoSchedModel },
 { "XEHP", { { { 0x5aULL, 0x0ULL, 0x0ULL, } } }, &NoSchedModel },
 { "generic", { { { 0x0ULL, 0x0ULL, 0x0ULL, } } }, &NoSchedModel },
};

namespace GenX_MC {
unsigned resolveVariantSchedClassImpl(unsigned SchedClass,
    const MCInst *MI, unsigned CPUID) {
  // Don't know how to resolve this scheduling class.
  return 0;
}
} // end namespace GenX_MC

struct GenXGenMCSubtargetInfo : public MCSubtargetInfo {
  GenXGenMCSubtargetInfo(const Triple &TT, 
    StringRef CPU, StringRef FS, ArrayRef<SubtargetFeatureKV> PF,
    ArrayRef<SubtargetSubTypeKV> PD,
    const MCWriteProcResEntry *WPR,
    const MCWriteLatencyEntry *WL,
    const MCReadAdvanceEntry *RA, const InstrStage *IS,
    const unsigned *OC, const unsigned *FP) :
      MCSubtargetInfo(TT, CPU, FS, PF, PD,
                      WPR, WL, RA, IS, OC, FP) { }

  unsigned resolveVariantSchedClass(unsigned SchedClass,
      const MCInst *MI, unsigned CPUID) const override {
    return GenX_MC::resolveVariantSchedClassImpl(SchedClass, MI, CPUID); 
  }
};

static inline MCSubtargetInfo *createGenXMCSubtargetInfoImpl(const Triple &TT, StringRef CPU, StringRef FS) {
  return new GenXGenMCSubtargetInfo(TT, CPU, FS, GenXFeatureKV, GenXSubTypeKV, 
                      GenXWriteProcResTable, GenXWriteLatencyTable, GenXReadAdvanceTable, 
                      nullptr, nullptr, nullptr);
}

} // end namespace llvm

#endif // GET_SUBTARGETINFO_MC_DESC


#ifdef GET_SUBTARGETINFO_TARGET_DESC
#undef GET_SUBTARGETINFO_TARGET_DESC

#include "llvm/Support/Debug.h"
#include "llvm/Support/raw_ostream.h"

// ParseSubtargetFeatures - Parses features string setting specified
// subtarget options.
void llvm::GenXSubtarget::ParseSubtargetFeatures(StringRef CPU, StringRef FS) {
  LLVM_DEBUG(dbgs() << "\nFeatures:" << FS);
  LLVM_DEBUG(dbgs() << "\nCPU:" << CPU << "\n\n");
  InitMCProcessorInfo(CPU, FS);
  const FeatureBitset& Bits = getFeatureBits();
  if (Bits[GenX::DumpRegAlloc]) DumpRegAlloc = true;
  if (Bits[GenX::FeatureFP64]) HasFP64 = true;
  if (Bits[GenX::FeatureHWTIDFromPredef]) GetsHWTIDFromPredef = true;
  if (Bits[GenX::FeatureInstrAdd64]) HasAdd64 = true;
  if (Bits[GenX::FeatureInstrBitRotate]) HasBitRotate = true;
  if (Bits[GenX::FeatureIntDivRem32]) HasIntDivRem32 = true;
  if (Bits[GenX::FeatureLongLong]) HasLongLong = true;
  if (Bits[GenX::FeatureLongLongEmulation]) EmulateLongLong = true;
  if (Bits[GenX::FeatureNoJmpi]) DisableJmpi = true;
  if (Bits[GenX::FeatureNoJumpTables]) DisableJumpTables = true;
  if (Bits[GenX::FeatureSwitchjmp]) HasSwitchjmp = true;
  if (Bits[GenX::FeatureUseMulDDQ]) UseMulDDQ = true;
  if (Bits[GenX::FeatureVectorDecomp]) DisableVectorDecomposition = true;
  if (Bits[GenX::FeatureWAFusedEUNoMask]) WaNoMaskFusedEU = true;
  if (Bits[GenX::OCLRuntime]) OCLRuntime = true;
  if (Bits[GenX::WarnCallable]) WarnCallable = true;
}
#endif // GET_SUBTARGETINFO_TARGET_DESC


#ifdef GET_SUBTARGETINFO_HEADER
#undef GET_SUBTARGETINFO_HEADER

namespace llvm {
class DFAPacketizer;
namespace GenX_MC {
unsigned resolveVariantSchedClassImpl(unsigned SchedClass, const MCInst *MI, unsigned CPUID);
} // end namespace GenX_MC

struct GenXGenSubtargetInfo : public TargetSubtargetInfo {
  explicit GenXGenSubtargetInfo(const Triple &TT, StringRef CPU, StringRef FS);
public:
  unsigned resolveSchedClass(unsigned SchedClass,  const MachineInstr *DefMI, const TargetSchedModel *SchedModel) const override;
  unsigned resolveVariantSchedClass(unsigned SchedClass, const MCInst *MI, unsigned CPUID) const override;
  DFAPacketizer *createDFAPacketizer(const InstrItineraryData *IID) const;
};
} // end namespace llvm

#endif // GET_SUBTARGETINFO_HEADER


#ifdef GET_SUBTARGETINFO_CTOR
#undef GET_SUBTARGETINFO_CTOR

#include "llvm/CodeGen/TargetSchedule.h"

namespace llvm {
extern const llvm::SubtargetFeatureKV GenXFeatureKV[];
extern const llvm::SubtargetSubTypeKV GenXSubTypeKV[];
extern const llvm::MCWriteProcResEntry GenXWriteProcResTable[];
extern const llvm::MCWriteLatencyEntry GenXWriteLatencyTable[];
extern const llvm::MCReadAdvanceEntry GenXReadAdvanceTable[];
GenXGenSubtargetInfo::GenXGenSubtargetInfo(const Triple &TT, StringRef CPU, StringRef FS)
  : TargetSubtargetInfo(TT, CPU, FS, makeArrayRef(GenXFeatureKV, 16), makeArrayRef(GenXSubTypeKV, 14), 
                        GenXWriteProcResTable, GenXWriteLatencyTable, GenXReadAdvanceTable, 
                        nullptr, nullptr, nullptr) {}

unsigned GenXGenSubtargetInfo
::resolveSchedClass(unsigned SchedClass, const MachineInstr *MI, const TargetSchedModel *SchedModel) const {
  report_fatal_error("Expected a variant SchedClass");
} // GenXGenSubtargetInfo::resolveSchedClass

unsigned GenXGenSubtargetInfo
::resolveVariantSchedClass(unsigned SchedClass, const MCInst *MI, unsigned CPUID) const {
  return GenX_MC::resolveVariantSchedClassImpl(SchedClass, MI, CPUID);
} // GenXGenSubtargetInfo::resolveVariantSchedClass

} // end namespace llvm

#endif // GET_SUBTARGETINFO_CTOR


#ifdef GET_STIPREDICATE_DECLS_FOR_MC_ANALYSIS
#undef GET_STIPREDICATE_DECLS_FOR_MC_ANALYSIS

#endif // GET_STIPREDICATE_DECLS_FOR_MC_ANALYSIS


#ifdef GET_STIPREDICATE_DEFS_FOR_MC_ANALYSIS
#undef GET_STIPREDICATE_DEFS_FOR_MC_ANALYSIS

#endif // GET_STIPREDICATE_DEFS_FOR_MC_ANALYSIS

