/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         CISAparse
#define yylex           CISAlex
#define yyerror         CISAerror
#define yydebug         CISAdebug
#define yynerrs         CISAnerrs

#define yylval          CISAlval
#define yychar          CISAchar

/* Copy the first part of user declarations.  */
#line 9 "CISA.y" /* yacc.c:339  */

#include <stdio.h>
#include <math.h>
#include <string>
#include <vector>

#include "visa_igc_common_header.h"
#include "Common_ISA.h"
#include "Common_ISA_util.h"
#include "Common_ISA_framework.h"
#include "JitterDataStruct.h"
#include "VISAKernel.h"


//VISA_Type variable_declaration_and_type_check(char *var, Common_ISA_Var_Class type);
void CISAerror(CISA_IR_Builder* builder, char const* msg);
int yylex(CISA_IR_Builder *pBuilder);
extern int CISAlineno;


static bool ParseAlign(CISA_IR_Builder* pBuilder, const char *sym, VISA_Align &value);
static VISA_Align AlignBytesToVisaAlignment(int bytes);
static int DataTypeSizeOf(VISA_Type type);
static bool ParseEMask(CISA_IR_Builder* pBuilder, const char* sym, VISA_EMask_Ctrl &emask);




//
// check if the cond is true.
// if cond is false, then print errorMessage (syntax error) and YYABORT
#define MUST_HOLD(cond, errorMessage) \
  {if (!(cond)) {pBuilder->RecordParseError(CISAlineno, errorMessage); YYABORT;}}
#define PARSE_ERROR_AT(LINE,...)\
  {pBuilder->RecordParseError(LINE, __VA_ARGS__); YYABORT;}
#define PARSE_ERROR(...)\
    PARSE_ERROR_AT(CISAlineno, __VA_ARGS__)

// Use this to wrap API calls that return false, nullptr, or 0 on failure
// It's assumed that the API call reported the parse error
#define ABORT_ON_FAIL(X) \
    do \
        if (!(X)) \
            YYABORT;\
    while (0)
#define TRACE(S) \
    do { \
      if (CISAout && pBuilder->debugParse()) \
          fprintf(CISAout, "line %d: %s", CISAlineno, S); \
    } while (0)

std::deque<const char*> switchLabels;
char * switch_label_array[32];
std::vector<VISA_opnd*> RTRWOperands;
int num_parameters;

VISA_RawOpnd* rawOperandArray[16];

// global var for non-kernel attribute option.
// The var needs to be cleared before each use.
std::vector<attr_gen_struct*> AttrOptVar;

#ifdef _MSC_VER
#pragma warning(disable:4065; disable:4267)
#endif


#line 142 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 1
#endif

/* In a future release of Bison, this section will be replaced
   by #include "CISA.tab.hpp".  */
#ifndef YY_CISA_HOME_ABUILD_RPMBUILD_BUILD_BUILD_IGC_VISA_CISA_TAB_HPP_INCLUDED
# define YY_CISA_HOME_ABUILD_RPMBUILD_BUILD_BUILD_IGC_VISA_CISA_TAB_HPP_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif
#if YYDEBUG
extern int CISAdebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    ALIGN_KEYWORD = 258,
    ATOMIC_SUB_OP = 259,
    DIRECTIVE_DECL = 260,
    DIRECTIVE_FUNC = 261,
    DIRECTIVE_FUNCDECL = 262,
    DIRECTIVE_GLOBAL_FUNC = 263,
    DIRECTIVE_IMPLICIT = 264,
    DIRECTIVE_INPUT = 265,
    DIRECTIVE_KERNEL = 266,
    DIRECTIVE_KERNEL_ATTR = 267,
    DIRECTIVE_PARAMETER = 268,
    DIRECTIVE_VERSION = 269,
    ALIAS_EQ = 270,
    ALIGN_EQ = 271,
    ATTR_EQ = 272,
    OFFSET_EQ = 273,
    NUM_ELTS_EQ = 274,
    V_NAME_EQ = 275,
    SIZE_EQ = 276,
    V_TYPE_EQ_G = 277,
    V_TYPE_EQ_P = 278,
    V_TYPE_EQ_A = 279,
    V_TYPE_EQ_S = 280,
    V_TYPE_EQ_T = 281,
    CPS = 282,
    NON_UNIFORM_SAMPLER = 283,
    PIXEL_NULL_MASK = 284,
    RAW_SENDC_STRING = 285,
    RAW_SENDSC_EOT_STRING = 286,
    RAW_SENDSC_STRING = 287,
    RAW_SENDS_EOT_STRING = 288,
    RAW_SENDS_STRING = 289,
    RAW_SEND_STRING = 290,
    SAT = 291,
    SRCMOD_ABS = 292,
    SRCMOD_NEG = 293,
    SRCMOD_NEGABS = 294,
    SRCMOD_NOT = 295,
    BFN_OP = 296,
    DPAS_OP = 297,
    BF_CVT_OP = 298,
    ITYPE = 299,
    DECL_DATA_TYPE = 300,
    DFTYPE = 301,
    FTYPE = 302,
    HFTYPE = 303,
    VTYPE = 304,
    COND_MOD = 305,
    LANGLE = 306,
    RANGLE = 307,
    LBRACK = 308,
    RBRACK = 309,
    IND_LBRACK = 310,
    LPAREN = 311,
    RPAREN = 312,
    LBRACE = 313,
    RBRACE = 314,
    DOT = 315,
    COMMA = 316,
    SEMI = 317,
    COLON = 318,
    SLASH = 319,
    PERCENT = 320,
    EQUALS = 321,
    PLUS = 322,
    MINUS = 323,
    TIMES = 324,
    AMP = 325,
    CIRC = 326,
    PIPE = 327,
    TILDE = 328,
    BANG = 329,
    QUESTION = 330,
    LEQ = 331,
    GEQ = 332,
    EQ = 333,
    NEQ = 334,
    SHL = 335,
    SHRS = 336,
    SHRZ = 337,
    LABEL = 338,
    IDENT = 339,
    BUILTIN_NULL = 340,
    BUILTIN = 341,
    STRING_LIT = 342,
    NEWLINE = 343,
    RTWRITE_OPTION = 344,
    MEDIA_MODE = 345,
    OWORD_MODIFIER = 346,
    SAMPLER_CHANNEL = 347,
    CHANNEL_OUTPUT = 348,
    EXECMODE = 349,
    CNTRL = 350,
    FENCE_OPTIONS = 351,
    ADDR_ADD_OP = 352,
    UNARY_LOGIC_OP = 353,
    BINARY_LOGIC_OP = 354,
    TERNARY_LOGIC_OP = 355,
    QUATERNARY_LOGIC_OP = 356,
    SEL_OP = 357,
    MIN_OP = 358,
    MAX_OP = 359,
    ANTI_TRIG_OP = 360,
    MATH2_OP = 361,
    MATH3_OP = 362,
    ARITH2_OP = 363,
    ARITH3_OP = 364,
    ARITH4_OP = 365,
    ARITH4_OP2 = 366,
    CMP_OP = 367,
    SVM_OP = 368,
    SVM_SCATTER_OP = 369,
    SVM_GATHER4SCALED_OP = 370,
    SVM_SCATTER4SCALED_OP = 371,
    SVM_ATOMIC_OP = 372,
    OWORD_OP = 373,
    MEDIA_OP = 374,
    SCATTER_OP = 375,
    SCATTER_TYPED_OP = 376,
    SCATTER_SCALED_OP = 377,
    SCATTER4_SCALED_OP = 378,
    BARRIER_OP = 379,
    SBARRIER_SIGNAL = 380,
    SBARRIER_WAIT = 381,
    DWORD_ATOMIC_OP = 382,
    TYPED_ATOMIC_OP = 383,
    SAMPLE_OP = 384,
    SAMPLE_UNORM_OP = 385,
    VME_IME_OP = 386,
    VME_SIC_OP = 387,
    VME_FBR_OP = 388,
    BRANCH_OP = 389,
    RET_OP = 390,
    IFCALL = 391,
    FCALL = 392,
    FADDR = 393,
    SWITCHJMP_OP = 394,
    MOVS_OP = 395,
    SETP_OP = 396,
    MOV_OP = 397,
    FILE_OP = 398,
    LOC_OP = 399,
    CACHE_FLUSH_OP = 400,
    WAIT_OP = 401,
    FENCE_GLOBAL_OP = 402,
    FENCE_LOCAL_OP = 403,
    FENCE_SW_OP = 404,
    YIELD_OP = 405,
    SAMPLE_3D_OP = 406,
    LOAD_3D_OP = 407,
    SAMPLE4_3D_OP = 408,
    RESINFO_OP_3D = 409,
    SAMPLEINFO_OP_3D = 410,
    RTWRITE_OP_3D = 411,
    URBWRITE_OP_3D = 412,
    LIFETIME_START_OP = 413,
    LIFETIME_END_OP = 414,
    AVS_OP = 415,
    CALL_OP = 416,
    PRED_CNTL = 417,
    F32_LIT = 418,
    F64_LIT = 419,
    DEC_LIT = 420,
    HEX_LIT = 421,
    BUILTIN_SIZEOF = 422,
    BUILTIN_DISPATCH_SIMD_SIZE = 423,
    QW_SCATTER_OP = 424
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 88 "CISA.y" /* yacc.c:355  */

    int64_t                intval;
    double                 fltval;

    struct strlitbuf_struct {
        char      decoded[4096];
        size_t    len;
    } strlit;
    char *                 string;

    VISA_Type              type;
    ISA_Opcode             opcode;
    bool                   sat;

    VISA_Cond_Mod          cond_mod;

    VISA_opnd *            pred_reg;
    VISA_PREDICATE_STATE   pred_sign;
    VISA_PREDICATE_CONTROL pred_ctrl;

    // to tell call is fc_call or subroutine call
    struct call_sub_or_fc {
        ISA_Opcode opcode;
        bool       is_fccall;
    } cisa_call;

    struct {
        VISA_Modifier mod;
    } src_mod;

    struct {
        unsigned int v_stride;
        unsigned int h_stride;
        unsigned int width;
    } cisa_region;

    struct {
        int                row;
        int                elem;
    } offset;

    struct {
        Common_ISA_Operand_Class type;
        VISA_opnd * cisa_gen_opnd;
    } genOperand;

    struct {
        char * var_name;
        VISA_opnd * cisa_gen_opnd;
        unsigned char streamMode;
        unsigned char searchCtrl;
    } vmeOpndIvb;

    struct {
        VISA_opnd * cisa_fbrMbMode_opnd;
        VISA_opnd * cisa_fbrSubMbShape_opnd;
        VISA_opnd * cisa_fbrSubPredMode_opnd;
    } vmeOpndFbr;

    struct {
        int            row;
        int            elem;
        int            immOff;
        VISA_opnd *    cisa_gen_opnd;
        CISA_GEN_VAR * cisa_decl;
    } regAccess;

    struct {
        char *             aliasname;
        int                offset;
    } alias;

    VISA_opnd * RawVar;

    struct {
        Common_ISA_State_Opnd type;
        unsigned char offset;
        VISA_opnd * cisa_gen_opnd;
    } StateVar;

    struct {
        VISA_EMask_Ctrl emask;
        int exec_size;
    } emask_exec_size;

    struct attr_gen_struct*  pattr_gen;

    struct dpas_info_struct {
        ISA_Opcode    opcode;
        GenPrecision  src2Precision;
        GenPrecision  src1Precision;
        uint8_t       depth;
        uint8_t       count;
    } dpas_info;

    struct bfn_op_struct {
        uint8_t func_ctrl;
    } bfn_info;


    // Align Support in Declaration
    VISA_Align             align;

    VISAAtomicOps          atomic_op;
    VISASampler3DSubOpCode sample3DOp;

    MEDIA_LD_mod           media_mode;
    bool                   oword_mod;
    VISAChannelMask        s_channel; // Cannot use ChannelMask here as it's a member of union where non-trivial constructor is not allowed.
    CHANNEL_OUTPUT_FORMAT  s_channel_output;
    VISA_EMask_Ctrl        emask;
    OutputFormatControl    cntrl;
    AVSExecMode            execMode;
    unsigned char          fence_options;

    // Pixel null mask for sampler instructions.
    bool                   pixel_null_mask;

    // CPS LOD compensation enable for 3d sample.
    bool                   cps;
    bool                   non_uniform_sampler;
    bool                   flag;

    CISA_GEN_VAR*          vISADecl;

#line 478 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE CISAlval;

int CISAparse (CISA_IR_Builder* pBuilder);

#endif /* !YY_CISA_HOME_ABUILD_RPMBUILD_BUILD_BUILD_IGC_VISA_CISA_TAB_HPP_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 495 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  5
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2574

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  170
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  162
/* YYNRULES -- Number of rules.  */
#define YYNRULES  366
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  915

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   424

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   519,   519,   524,   526,   526,   528,   528,   529,   529,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   547,   548,   549,   553,   557,   560,   560,   567,   575,
     583,   590,   591,   592,   593,   594,   595,   597,   604,   612,
     620,   627,   631,   631,   634,   642,   647,   659,   666,   674,
     674,   675,   682,   688,   692,   696,   700,   705,   711,   711,
     713,   717,   723,   731,   737,   742,   747,   753,   757,   761,
     767,   772,   778,   782,   792,   793,   794,   795,   796,   797,
     798,   799,   800,   801,   802,   803,   804,   805,   806,   807,
     808,   809,   810,   811,   812,   813,   814,   815,   816,   817,
     818,   819,   820,   821,   822,   823,   824,   825,   826,   827,
     828,   829,   830,   831,   832,   833,   834,   835,   836,   837,
     838,   839,   840,   843,   847,   853,   858,   864,   872,   878,
     885,   892,   899,   906,   917,   924,   933,   943,   949,   956,
     963,   972,   982,   989,   996,  1004,  1013,  1020,  1026,  1032,
    1038,  1056,  1063,  1073,  1081,  1088,  1095,  1104,  1113,  1122,
    1130,  1133,  1136,  1141,  1148,  1156,  1157,  1163,  1172,  1180,
    1188,  1200,  1200,  1202,  1202,  1205,  1218,  1230,  1230,  1233,
    1241,  1249,  1252,  1256,  1261,  1271,  1271,  1275,  1283,  1295,
    1311,  1317,  1330,  1338,  1345,  1351,  1357,  1363,  1370,  1371,
    1378,  1381,  1384,  1391,  1395,  1399,  1403,  1409,  1414,  1421,
    1426,  1431,  1437,  1444,  1451,  1457,  1463,  1471,  1479,  1487,
    1496,  1501,  1506,  1511,  1516,  1521,  1526,  1531,  1536,  1536,
    1542,  1547,  1552,  1552,  1554,  1554,  1557,  1557,  1560,  1561,
    1562,  1563,  1565,  1565,  1570,  1571,  1573,  1574,  1578,  1579,
    1582,  1583,  1586,  1587,  1588,  1591,  1592,  1595,  1596,  1597,
    1600,  1601,  1604,  1605,  1607,  1609,  1619,  1626,  1634,  1642,
    1661,  1673,  1680,  1692,  1697,  1704,  1709,  1717,  1725,  1731,
    1736,  1758,  1762,  1768,  1778,  1786,  1793,  1803,  1809,  1816,
    1820,  1825,  1829,  1835,  1836,  1843,  1851,  1852,  1858,  1868,
    1876,  1885,  1903,  1917,  1920,  1931,  1942,  1947,  1952,  1960,
    1969,  1981,  1995,  1997,  2008,  2020,  2026,  2034,  2043,  2043,
    2044,  2044,  2047,  2049,  2050,  2052,  2053,  2055,  2056,  2058,
    2059,  2061,  2062,  2063,  2065,  2066,  2067,  2068,  2069,  2086,
    2089,  2090,  2091,  2092,  2094,  2095,  2096,  2098,  2099,  2104,
    2109,  2111,  2112,  2113,  2114,  2118,  2119,  2121,  2125,  2129,
    2135,  2144,  2145,  2146,  2147,  2149,  2150
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 1
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "ALIGN_KEYWORD", "ATOMIC_SUB_OP",
  "DIRECTIVE_DECL", "DIRECTIVE_FUNC", "DIRECTIVE_FUNCDECL",
  "DIRECTIVE_GLOBAL_FUNC", "DIRECTIVE_IMPLICIT", "DIRECTIVE_INPUT",
  "DIRECTIVE_KERNEL", "DIRECTIVE_KERNEL_ATTR", "DIRECTIVE_PARAMETER",
  "DIRECTIVE_VERSION", "ALIAS_EQ", "ALIGN_EQ", "ATTR_EQ", "OFFSET_EQ",
  "NUM_ELTS_EQ", "V_NAME_EQ", "SIZE_EQ", "V_TYPE_EQ_G", "V_TYPE_EQ_P",
  "V_TYPE_EQ_A", "V_TYPE_EQ_S", "V_TYPE_EQ_T", "CPS",
  "NON_UNIFORM_SAMPLER", "PIXEL_NULL_MASK", "RAW_SENDC_STRING",
  "RAW_SENDSC_EOT_STRING", "RAW_SENDSC_STRING", "RAW_SENDS_EOT_STRING",
  "RAW_SENDS_STRING", "RAW_SEND_STRING", "SAT", "SRCMOD_ABS", "SRCMOD_NEG",
  "SRCMOD_NEGABS", "SRCMOD_NOT", "BFN_OP", "DPAS_OP", "BF_CVT_OP", "ITYPE",
  "DECL_DATA_TYPE", "DFTYPE", "FTYPE", "HFTYPE", "VTYPE", "COND_MOD",
  "LANGLE", "RANGLE", "LBRACK", "RBRACK", "IND_LBRACK", "LPAREN", "RPAREN",
  "LBRACE", "RBRACE", "DOT", "COMMA", "SEMI", "COLON", "SLASH", "PERCENT",
  "EQUALS", "PLUS", "MINUS", "TIMES", "AMP", "CIRC", "PIPE", "TILDE",
  "BANG", "QUESTION", "LEQ", "GEQ", "EQ", "NEQ", "SHL", "SHRS", "SHRZ",
  "LABEL", "IDENT", "BUILTIN_NULL", "BUILTIN", "STRING_LIT", "NEWLINE",
  "RTWRITE_OPTION", "MEDIA_MODE", "OWORD_MODIFIER", "SAMPLER_CHANNEL",
  "CHANNEL_OUTPUT", "EXECMODE", "CNTRL", "FENCE_OPTIONS", "ADDR_ADD_OP",
  "UNARY_LOGIC_OP", "BINARY_LOGIC_OP", "TERNARY_LOGIC_OP",
  "QUATERNARY_LOGIC_OP", "SEL_OP", "MIN_OP", "MAX_OP", "ANTI_TRIG_OP",
  "MATH2_OP", "MATH3_OP", "ARITH2_OP", "ARITH3_OP", "ARITH4_OP",
  "ARITH4_OP2", "CMP_OP", "SVM_OP", "SVM_SCATTER_OP",
  "SVM_GATHER4SCALED_OP", "SVM_SCATTER4SCALED_OP", "SVM_ATOMIC_OP",
  "OWORD_OP", "MEDIA_OP", "SCATTER_OP", "SCATTER_TYPED_OP",
  "SCATTER_SCALED_OP", "SCATTER4_SCALED_OP", "BARRIER_OP",
  "SBARRIER_SIGNAL", "SBARRIER_WAIT", "DWORD_ATOMIC_OP", "TYPED_ATOMIC_OP",
  "SAMPLE_OP", "SAMPLE_UNORM_OP", "VME_IME_OP", "VME_SIC_OP", "VME_FBR_OP",
  "BRANCH_OP", "RET_OP", "IFCALL", "FCALL", "FADDR", "SWITCHJMP_OP",
  "MOVS_OP", "SETP_OP", "MOV_OP", "FILE_OP", "LOC_OP", "CACHE_FLUSH_OP",
  "WAIT_OP", "FENCE_GLOBAL_OP", "FENCE_LOCAL_OP", "FENCE_SW_OP",
  "YIELD_OP", "SAMPLE_3D_OP", "LOAD_3D_OP", "SAMPLE4_3D_OP",
  "RESINFO_OP_3D", "SAMPLEINFO_OP_3D", "RTWRITE_OP_3D", "URBWRITE_OP_3D",
  "LIFETIME_START_OP", "LIFETIME_END_OP", "AVS_OP", "CALL_OP", "PRED_CNTL",
  "F32_LIT", "F64_LIT", "DEC_LIT", "HEX_LIT", "BUILTIN_SIZEOF",
  "BUILTIN_DISPATCH_SIMD_SIZE", "QW_SCATTER_OP", "$accept", "Listing",
  "ListingHeader", "Statements", "Newlines", "NewlinesOpt", "Statement",
  "Scope", "ScopeStart", "ScopeEnd", "IdentOrStringLit", "DirectiveKernel",
  "DirectiveGlobalFunction", "DirectiveVersion", "DirectiveDecl",
  "DeclFunction", "DeclVariable", "DeclAddress", "DeclPredicate",
  "DeclSampler", "VNameEqOpt", "DeclSurface", "DirectiveInput",
  "DirectiveImplicitInput", "InputOffset", "InputSize",
  "DirectiveParameter", "DirectiveAttr", "DirectiveFunc", "AlignAttrOpt",
  "Align", "AliasAttrOpt", "OneAttr", "AttrOpt", "GenAttrOpt",
  "Instruction", "Label", "LogicInstruction", "UnaryLogicInstruction",
  "MathInstruction_2OPND", "MathInstruction_3OPND",
  "ArithInstruction_2OPND", "ArithInstruction_3OPND",
  "ArithInstruction_4OPND", "DpasInstruction", "BfnInstruction",
  "QwScatterInstruction", "BF_CvtInstruction", "AntiTrigInstruction",
  "AddrAddInstruction", "SetpInstruction", "SelInstruction",
  "MinInstruction", "MaxInstruction", "MovInstruction", "MovsInstruction",
  "CmpInstruction", "MediaInstruction", "MediaInstructionPlaneID",
  "ScatterInstruction", "ScatterTypedInstruction",
  "Scatter4ScaledInstruction", "ScatterScaledInstruction",
  "SynchronizationInstruction", "DwordAtomicInstruction",
  "TypedAtomicInstruction", "Atomic16Opt", "SampleUnormInstruction",
  "SampleInstruction", "Sample3dInstruction", "CPSEnableOpt",
  "NonUniformSamplerEnableOpt", "Load3dInstruction",
  "Gather43dInstruction", "PixelNullMaskEnableOpt", "ResInfo3dInstruction",
  "SampleInfo3dInstruction", "RTWriteOperandParse", "RTWriteInstruction",
  "RTWriteModeOpt", "URBWriteInstruction", "AVSInstruction",
  "VMEInstruction", "OwordInstruction", "SvmInstruction",
  "AtomicBitwidthOpt", "SwitchLabels", "BranchInstruction", "FILE", "LOC",
  "RawSendInstruction", "LifetimeStartInst", "LifetimeEndInst",
  "RawSendsInstruction", "NullaryInstruction", "OwordModifier",
  "Predicate", "PredSign", "PredCtrlOpt", "SatModOpt", "SrcModifier",
  "ConditionalModifier", "VecDstOperand_A", "VecDstOperand_G",
  "VecDstOperand_G_I", "VecSrcOperand_G_I_IMM_A_AO",
  "VecSrcOperand_G_I_IMM_A", "VecSrcOperand_G_I_IMM",
  "VecSrcOperand_G_IMM", "VecSrcOperand_G_IMM_AO", "VecSrcOperand_G_A",
  "VecSrcOperand_G_A_AO", "VecSrcOperand_G", "VecSrcOpndSimple",
  "VMEOpndIME", "VMEOpndFBR", "SrcStateOperand", "DstStateOperand",
  "RawOperand", "RawOperandNonNull", "RawOperandOffsetSuffix",
  "RawOperandArray", "DstAddrOperand", "DstGeneralOperand",
  "DstIndirectOperand", "SrcAddrOfOperand", "AddrOfVar", "SrcAddrOperand",
  "SrcGeneralOperand", "SrcImmOperand", "FloatLit", "DoubleFloatLit",
  "SrcIndirectOperand", "DstRegion", "SrcRegionDirect",
  "SrcRegionIndirect", "IndirectVarAccess", "TwoDimOffset", "PredVar",
  "AddrVarAccess", "AddrVarAccessWithWidth", "SIMDMode", "ElemNum",
  "ExecSize", "ExecSizeInt", "Var", "VarNonNull", "IntExp", "IntExpCond",
  "IntExpAND", "IntExpXOR", "IntExpOR", "IntExpCmp", "IntExpRel",
  "IntExpNRA", "IntExpShift", "IntExpAdd", "IntExpMul", "IntExpUnr",
  "IntExpPrim", "DataType", "DataTypeIntOrVector", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424
};
# endif

#define YYPACT_NINF -833

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-833)))

#define YYTABLE_NINF -356

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     -71,  -833,    23,   -59,    21,  -833,  -833,  -102,   -71,  -833,
      16,  2414,   -77,   100,    -5,    20,    -5,   105,   119,    -5,
     121,   127,    44,    44,   125,  -833,  -833,    44,   164,    44,
     148,   128,   175,  -833,  -833,  -833,   153,   155,   193,    38,
     205,   186,    44,    44,    44,   226,   133,  -833,   981,   209,
     219,  -833,  -833,   222,   224,   233,   234,   236,   -71,  -833,
    -833,  2016,  -833,  -833,  -833,  -833,  -833,  -833,  -833,  -833,
    -833,  -833,  -833,  -833,  -833,  -833,  -833,  -833,  -833,  -833,
    -833,  -833,  -833,  -833,  -833,  -833,  -833,  -833,  -833,  -833,
    -833,  -833,  -833,  -833,  -833,  -833,  -833,  -833,  -833,  -833,
    -833,  -833,  -833,  -833,  -833,  -833,  -833,  -833,  -833,  -833,
    -833,  -833,  -833,  -833,  -833,  -833,  -833,  -833,  -833,  -833,
    -833,  -833,  -833,  -833,  -833,  -833,  -833,  1736,  -833,   271,
    -833,  -833,  -833,  -833,  -833,   301,   301,  -833,   260,   308,
     -52,    86,    38,  -833,    38,    38,  -833,    44,   157,  -833,
      44,   274,   166,    44,   293,   258,   187,    38,  -833,  -833,
    -833,    86,  -833,   157,    38,   -33,   157,    38,    38,  -833,
    -833,  -833,  -833,  -833,  -833,   -31,   410,   -31,   -31,  -833,
    -833,    98,   227,   -25,  -833,    38,  -833,  -833,  -833,  -833,
    -833,  -833,   274,    53,  -833,  -833,  -833,    44,    44,  -833,
    -833,    38,  2199,  -833,  -833,  2355,    44,   175,   175,   175,
     175,    44,   317,   317,   317,   317,   317,   317,   317,   317,
     317,   317,   317,   317,   317,   317,    44,   294,   267,   268,
     363,   276,   309,   278,   368,   369,    44,    44,    44,    44,
     317,   347,   347,   347,   290,    44,    44,   322,   338,   365,
     366,   371,   372,   -31,    43,   308,   142,   -31,   375,  -833,
     331,   333,   335,    86,  -833,   336,   981,  -833,    64,   237,
    -833,   469,  -833,  -833,   342,   -33,    38,   -33,    86,  -833,
    -833,  -833,   350,    38,   -31,    38,  -833,   148,   240,    38,
      38,   345,    86,    86,   348,    86,  -833,  -833,  -833,   362,
     358,    38,   157,    82,   157,   -31,  -833,  -833,   359,  -833,
      73,   344,   346,  -833,   144,   103,  -833,   120,     8,  -833,
     114,  -833,  -833,  -833,  -833,  -833,  -833,  -833,  -833,  -833,
    -833,   356,  -833,   274,   390,  -833,  -833,  -833,    38,    38,
      38,  -833,  -833,   -71,  -833,   251,   175,   175,   175,   175,
     277,  -833,    44,    44,    44,    44,    44,    44,    44,    44,
      44,    44,    44,    44,    44,    44,   -33,   279,    44,    44,
     385,    44,   281,    44,   387,   387,    -5,  -833,   157,   364,
      44,  -833,   423,   378,   382,  -833,    44,   310,    -5,   311,
     462,   -31,   -31,   -31,   -31,  -833,   424,   375,  -833,  -833,
    -833,  -833,  -833,  -833,  -833,   321,   323,    86,   -35,  -833,
    -833,   -31,  -833,   362,  -833,   430,    38,  -833,    10,  -833,
    -833,   436,  -833,  -833,   434,   -31,   157,   157,    64,     0,
     435,   350,  -833,   -31,  -833,   211,   157,   432,   739,    38,
     437,   218,    38,   332,    86,    86,   157,    86,   211,   -17,
    -833,   440,  -833,  -833,   443,   -31,  -833,  -833,   -31,   -31,
     -31,   -31,   -31,   -31,   -31,   -31,   -31,   -31,   -31,   -31,
     -31,   -31,   -31,   -31,   -31,   -31,   444,   390,   -31,  -833,
      86,    86,   157,   441,   339,   175,   175,   175,   175,   349,
     -33,   -33,   -33,   -33,   -33,   -33,   -33,   -33,   -33,   -33,
     -33,   -33,   -33,   -33,   -33,   450,   157,   157,   351,    44,
      38,    44,    38,   352,    44,    44,  -833,   360,   361,   -33,
    -833,   475,    44,    44,    38,   367,  -833,    44,   -31,   375,
     375,   495,   495,   439,  -833,   467,  -833,    38,   -31,  -833,
     476,  -833,  -833,  -833,  -833,  -833,  -833,  -833,   -31,   -31,
     470,   157,   157,  -833,   -31,   -31,   211,   165,   106,  -833,
    -833,  -833,  -833,  -833,    86,   -31,   160,   157,   157,   157,
    -833,   335,    86,    86,   336,   157,   473,    86,  -833,   472,
      86,  -833,   -17,   -17,   474,   -31,   -31,    47,   344,    -8,
     346,  -833,  -833,  -833,  -833,  -833,  -833,  -833,     8,     8,
     185,   185,   185,  -833,  -833,  -833,  -833,  -833,   478,    86,
    -833,   157,  -833,   370,    44,    44,   175,   175,   373,   157,
     157,    38,   157,    38,   157,   157,   157,   157,   157,   157,
     157,   157,   157,   157,   157,   157,   376,    86,    86,  -833,
      86,    86,    38,   157,  -833,    38,    38,   377,   383,     1,
    -833,   442,   157,   157,  -833,    86,    38,   520,  -833,  -833,
     453,   375,   375,   477,  -833,    55,  -833,  -833,   274,   494,
    -833,   498,   102,   506,  -833,  -833,   504,   507,  -833,   396,
     -31,   -31,  -833,   508,   157,    86,    86,    86,    86,   157,
    -833,    86,   157,  -833,  -833,  -833,  -833,   509,   124,  -833,
     -31,  -833,   157,   981,   981,   981,    44,    44,   981,   157,
    -833,  -833,   157,    38,   157,   157,   157,   157,   157,  -833,
    -833,   157,  -833,   157,   157,   157,    44,    86,    86,    86,
      86,   157,    86,    86,    86,  -833,  -833,  -833,  -833,  -833,
    -833,  -833,  -833,   434,    44,    38,    38,  1045,    86,    86,
      25,   548,  -833,  -833,  -833,  -833,   198,  -833,   439,  -833,
    -833,  -833,   -31,  -833,  -833,   515,   510,  -833,    86,  -833,
      86,    86,    86,   157,    86,   513,  -833,  -833,   157,    86,
     981,   981,   981,   981,    86,   157,  -833,  -833,   157,   157,
    -833,  -833,  -833,  -833,  -833,   157,  -833,    86,  -833,  -833,
      86,    86,    86,    86,    86,    86,   157,    86,    38,  -833,
    -833,    86,    86,  -833,  -833,  -833,  -833,   521,   375,  -833,
    -833,  -833,   527,  -833,   -31,  -833,  -833,  -833,    86,   157,
      86,  -833,   157,    86,    86,    86,   981,   981,    86,  -833,
    -833,   157,  -833,    86,    86,    86,    86,  -833,    86,    86,
      38,  -833,    86,    86,  -833,    26,  -833,  -833,   528,  -833,
      86,  -833,   157,  -833,    86,    86,    86,    86,  -833,  -833,
    -833,  -833,    86,  -833,    86,    86,    38,    86,  -833,  -833,
    -833,   522,  -833,  -833,   157,    86,    86,    86,    86,  -833,
    -833,    86,    86,  -833,    86,   -31,   486,  -833,  -833,    86,
      86,    86,  -833,   533,   157,  -833,  -833,    86,    86,  -833,
     492,  -833,   157,    86,  -833
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       8,     7,     0,     9,     0,     1,     6,     0,     8,     3,
       0,   230,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   232,    24,   123,     0,   242,     0,
     228,     0,     0,   160,   161,   162,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   220,     0,   223,
     225,   227,   222,     0,     0,     0,     0,     0,     8,     5,
      20,     0,    11,    12,    10,    36,    31,    32,    33,    34,
      35,    14,    13,    15,    17,    16,    18,    19,    74,    76,
      77,    78,    79,    80,    81,   119,   120,   121,   122,    82,
      83,   104,   101,   102,   103,   100,    99,    84,    85,    87,
      88,    90,    89,    91,    93,    94,    96,    95,   109,   110,
     111,   112,   113,   114,   115,    98,    97,    86,    75,    92,
     105,   106,   107,   116,   117,   108,   118,     0,    30,     0,
      26,    27,    57,    37,    29,    49,    49,    28,    55,     0,
       0,     0,     0,   233,     0,     0,   243,     0,     0,   229,
       0,     0,     0,     0,   312,     0,     0,     0,   320,   319,
     321,     0,   318,     0,     0,     0,     0,     0,     0,   210,
     211,   239,   238,   240,   241,     0,     0,     0,     0,   293,
     296,   355,   356,     0,   360,     0,   221,   255,   264,   256,
     289,   291,     0,     0,   354,   224,   226,     0,     0,   214,
     215,     0,   230,     2,    23,   230,     0,     0,     0,     0,
       0,     0,   236,   236,   236,   236,   236,   236,   236,   236,
     236,   236,   236,   236,   236,   236,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   177,   177,   177,   185,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    72,    46,    56,     0,    72,   317,
       0,     0,     0,     0,   270,     0,     0,   245,     0,   234,
     309,     0,   244,   277,     0,     0,     0,     0,     0,   252,
     254,   253,     0,     0,     0,     0,   314,   228,     0,     0,
       0,     0,     0,     0,     0,     0,   209,   246,   247,     0,
       0,     0,     0,     0,     0,     0,   355,   356,     0,   322,
     324,   326,   328,   330,   333,   338,   339,   343,   346,   350,
     356,   290,   292,   351,   352,   353,   297,   294,   298,   295,
     288,     0,   358,     0,     0,   365,   366,   287,     0,     0,
       0,     4,    25,     8,    21,     0,     0,     0,     0,     0,
       0,   237,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     198,     0,     0,     0,   165,   165,     0,   205,     0,     0,
       0,   178,   171,     0,     0,   186,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    50,     0,    72,    48,    45,
      53,    54,    51,    52,   315,     0,     0,     0,     0,   272,
     139,     0,   279,     0,   235,     0,     0,   262,     0,   260,
     263,   281,   261,   284,     0,     0,     0,     0,   309,     0,
       0,     0,   193,     0,   303,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   200,
     149,     0,   150,   148,     0,     0,   142,   357,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   285,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   203,     0,     0,     0,
     172,   173,     0,     0,     0,     0,   204,     0,     0,    72,
      72,    42,    42,     0,    47,     0,   271,     0,     0,   273,
       0,   278,   231,   283,   141,   257,   259,   258,     0,     0,
       0,     0,     0,   307,     0,     0,     0,     0,   338,   362,
     363,   364,   299,   361,     0,     0,   155,     0,     0,     0,
     313,   319,     0,     0,   318,     0,     0,     0,   190,     0,
       0,   280,   200,   200,     0,     0,     0,     0,   325,     0,
     327,   329,   331,   332,   334,   335,   336,   337,   344,   345,
     340,   341,   342,   348,   349,   347,   359,   286,     0,     0,
     180,     0,    22,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   199,
       0,     0,     0,     0,   166,     0,     0,     0,     0,     0,
     174,     0,     0,     0,   181,     0,     0,    58,    40,    39,
       0,    72,    72,    69,    71,     0,   316,   136,     0,     0,
     301,     0,     0,     0,   152,   151,     0,     0,   300,     0,
       0,   305,   192,     0,     0,     0,     0,     0,     0,     0,
     266,     0,     0,   191,   201,   202,   206,     0,     0,   269,
       0,   179,     0,     0,     0,     0,     0,     0,     0,     0,
     128,   129,     0,     0,     0,     0,     0,     0,     0,   140,
     130,     0,   132,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   208,   207,   146,   248,   250,
     249,   251,   147,   309,     0,     0,     0,   184,     0,     0,
       0,    64,    59,    43,    41,    44,     0,    73,     0,   265,
     274,   282,     0,   306,   310,     0,     0,   308,     0,   154,
       0,     0,     0,     0,     0,     0,   268,   323,     0,     0,
       0,     0,     0,     0,     0,     0,   124,   125,     0,     0,
     143,   144,   145,   131,   133,     0,   135,     0,   196,   197,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   182,
     183,     0,     0,    63,    60,    61,    62,     0,    72,    68,
      67,    70,     0,   304,     0,   153,   156,   169,     0,     0,
       0,   267,     0,     0,     0,     0,     0,     0,     0,   137,
     126,     0,   134,     0,     0,     0,     0,   158,     0,     0,
       0,   275,     0,     0,   138,     0,    38,   311,     0,   168,
       0,   189,     0,   213,     0,     0,     0,     0,   212,   127,
     194,   195,     0,   159,     0,     0,     0,   175,   275,   187,
      66,     0,   302,   167,     0,     0,     0,     0,     0,   157,
     163,     0,     0,   276,   176,     0,     0,   219,   218,     0,
       0,     0,   275,     0,     0,   217,   216,     0,   170,    65,
       0,   164,     0,     0,   188
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -833,  -833,  -833,   384,   -55,     7,   386,  -833,  -833,   104,
     -14,  -833,  -833,  -833,  -833,  -833,  -833,  -833,  -833,  -833,
      58,  -833,  -833,  -833,   455,    13,  -833,  -833,  -833,  -833,
    -833,  -833,  -166,  -833,  -250,  -833,  -833,  -833,  -833,  -833,
    -833,  -833,  -833,  -833,  -833,  -833,  -833,  -833,  -833,  -833,
    -833,  -833,  -833,  -833,  -833,  -833,  -833,  -833,  -833,  -833,
    -833,  -833,  -833,  -833,  -833,  -833,   223,  -833,  -833,  -833,
    -833,  -833,  -833,  -833,    22,  -833,  -833,  -833,  -833,  -833,
    -833,  -833,  -833,  -833,  -833,  -833,  -305,  -833,  -833,  -833,
    -833,  -833,  -833,  -833,  -833,   306,  -833,  -833,  -833,   715,
     -47,  -833,  -833,   427,   129,  -833,  -833,   970,  -236,  -833,
    -833,  -833,   -38,  -833,  -833,  -833,   295,  -833,   598,  -833,
    -833,  -832,  -833,  -122,  -833,  -409,  -833,   -50,  -833,   -32,
     426,   428,  -833,  -281,  -328,   174,  -158,  -147,  -144,  -833,
     463,  -833,  -196,  1583,   204,   -39,   115,   639,   -89,   154,
     156,   152,   173,  -176,  -375,  -833,  -188,  -157,   -36,  -833,
    -429,   422
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     8,    58,     3,     4,    59,    60,    61,   344,
     132,    62,    63,     9,    64,    65,    66,    67,    68,    69,
     661,    70,    71,    72,   254,   258,    73,    74,    75,   751,
     752,   818,   664,   665,   398,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,   567,    99,
     100,   101,   102,   103,   104,   105,   514,   106,   107,   108,
     521,   651,   109,   110,   382,   111,   112,   747,   113,   386,
     114,   115,   116,   117,   118,   509,   584,   119,   120,   121,
     122,   123,   124,   125,   126,   150,   127,   144,   415,   352,
     277,   147,   271,   266,   296,   737,   738,   278,   186,   544,
     417,   418,   279,   667,   157,   164,   450,   302,   893,   264,
     409,   877,   272,   297,   298,   420,   421,   422,   188,   280,
     190,   191,   281,   412,   434,   435,   282,   334,   269,   429,
     423,   289,   153,   141,   260,   192,   162,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   193,   194,
     562,   563
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     161,   185,   134,   202,   285,   137,   479,   299,   403,   546,
     187,   346,   347,   348,   349,    11,   189,     1,   448,   581,
     267,   538,   276,     5,   304,   175,   813,   880,   814,     6,
     410,   331,   158,   159,   160,     7,   540,   305,   171,   172,
     173,   174,   177,   178,   582,   267,   894,   171,   172,   173,
     174,   158,   159,   160,   553,   700,   276,   175,   558,   332,
     396,   554,   458,    10,   257,   203,   175,   583,   205,   176,
     908,   416,   473,   474,   177,   178,    12,   475,   176,   130,
     416,   175,   131,   177,   178,   158,   159,   160,   128,   594,
     595,   596,   597,   305,   158,   159,   160,   335,   177,   178,
     140,   261,   336,   268,   699,   270,   274,   133,   565,   815,
     158,   159,   160,   259,   757,   411,   758,   299,   292,   431,
     284,   413,   158,   159,   160,   295,   268,   678,   303,   270,
     539,   427,   541,   411,   306,   307,   183,   184,   455,   319,
     323,   324,   325,   458,   326,   327,   333,   534,   459,   607,
     485,   486,   487,   488,   464,   465,   413,   464,   681,   673,
     328,   329,   340,   565,   179,   180,   181,   182,   183,   184,
     158,   262,   160,   179,   180,   181,   182,   183,   184,   466,
     467,   776,   466,   467,   129,   565,   477,   468,   469,   135,
     306,   307,   183,   184,   171,   172,   173,   174,   175,   143,
     470,   471,   472,   136,  -355,   138,   326,   327,   299,  -355,
     305,   139,   276,   175,   146,   177,   178,   319,   151,   185,
     319,   319,   462,   463,   185,   176,   679,   680,   187,   400,
     177,   178,   424,   419,   189,   152,   428,   430,   333,   149,
     740,   158,   159,   160,   436,   154,   438,   155,   319,   156,
     441,   442,   468,   469,   175,   335,   265,   559,   560,   561,
     336,   163,   451,   454,   383,   384,   305,   397,   399,   323,
     165,   177,   178,   328,   329,   330,   265,   694,   695,   658,
     659,   413,   600,   601,   602,   819,   592,   593,   202,   614,
     615,   616,   617,   248,   249,   250,   251,   252,   170,   480,
     481,   482,   158,   571,   160,   195,   595,   306,   307,   183,
     184,   598,   599,   169,   197,   196,   198,   199,   200,   253,
     179,   180,   181,   182,   183,   184,   256,   268,   201,   257,
     284,   286,   299,   299,   299,   299,   299,   299,   299,   299,
     299,   299,   299,   299,   299,   299,   299,   621,   623,   288,
     483,   290,   291,   351,   367,   319,   319,   319,   319,   368,
     369,   299,   516,   306,   307,   183,   184,   370,   371,   372,
     373,   185,   374,   375,   526,   319,   381,   543,   265,   385,
     545,   820,   389,   390,   391,   392,   547,   822,   404,   319,
     393,   394,   396,   265,   405,   406,   408,   319,   425,   414,
     569,   433,   573,   575,   426,   440,   443,   265,   265,   446,
     265,   754,   755,   411,   449,   460,   457,   484,   461,   319,
     706,   707,   319,   319,   319,   319,   319,   319,   319,   319,
     319,   319,   319,   319,   319,   319,   319,   603,   604,   605,
     476,   478,   319,   489,   505,   508,   511,   513,   518,   858,
     520,   268,   428,   428,   268,   268,   268,   268,   268,   268,
     268,   268,   268,   268,   268,   268,   175,   779,   780,   781,
     522,   641,   784,   643,   523,   525,   527,   711,   305,   713,
     268,   528,   533,   177,   178,   654,   259,   542,   536,   548,
     549,   555,   319,   565,   570,   504,   585,   576,   668,   586,
     342,   606,   319,   650,   613,   742,   171,   172,   173,   174,
     636,   809,   319,   319,   618,   660,   639,   644,   319,   319,
     903,   759,   265,   663,   666,   647,   648,   673,   670,   319,
     690,   696,   655,   692,   744,   703,   750,   753,   708,   416,
     680,   726,   735,   756,   834,   835,   836,   837,   736,   319,
     319,   760,   761,   158,   159,   160,   574,   762,   763,   265,
     265,   765,   265,   817,   764,   767,   776,   823,   856,   787,
     831,   824,   855,   179,   180,   181,   320,   183,   184,   857,
     882,   904,   270,   895,   270,   909,   912,   612,   341,   343,
     662,   255,   821,   439,   301,   265,   265,   453,   515,   741,
     866,   867,   321,   731,   322,   556,   733,   734,   273,   535,
     743,   777,   590,   589,   588,   337,     0,   749,     0,   619,
     620,   622,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   591,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   319,   319,     0,     0,   649,     0,
       0,     0,     0,     0,     0,     0,   185,   185,   185,     0,
       0,   185,     0,     0,   319,   187,   187,   187,     0,     0,
     187,   189,   189,   189,   270,     0,   189,     0,     0,   265,
       0,     0,     0,     0,     0,     0,     0,   265,   265,     0,
       0,     0,   265,     0,     0,   265,     0,     0,     0,     0,
     185,     0,     0,     0,     0,     0,   807,   808,     0,   187,
       0,     0,     0,     0,   319,   189,     0,     0,     0,     0,
     319,     0,     0,     0,   265,     0,   319,     0,     0,     0,
       0,     0,     0,   185,   185,   185,   185,     0,     0,   263,
       0,     0,   187,   187,   187,   187,     0,     0,   189,   189,
     189,   189,   265,   265,     0,   265,   265,     0,     0,   293,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   852,
     265,     0,     0,     0,     0,     0,   171,   172,   173,   174,
       0,     0,     0,     0,     0,     0,     0,     0,   319,   185,
     185,     0,     0,     0,   276,   175,     0,     0,   187,   187,
     265,   265,   265,   265,   189,   189,   265,   176,     0,     0,
       0,   876,   177,   178,     0,     0,   881,     0,     0,     0,
       0,     0,     0,   158,   159,   160,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   892,     0,     0,
       0,     0,   265,   265,   265,   265,     0,   265,   265,   265,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   319,
       0,   407,   574,   265,   265,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   432,     0,     0,     0,
       0,     0,     0,   265,     0,   265,   265,   265,     0,   265,
     444,   445,   395,   447,   265,   401,   402,     0,     0,   265,
       0,     0,   179,   180,   566,   182,   183,   184,     0,     0,
       0,     0,   265,     0,     0,   265,   265,   265,   265,   265,
     265,     0,   265,   437,     0,     0,   265,   265,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,     0,     0,   265,     0,   265,     0,     0,   265,   265,
     265,     0,     0,   265,     0,   380,     0,     0,   265,   265,
     265,   265,     0,   265,   265,     0,     0,   265,   265,     0,
       0,     0,     0,     0,     0,   265,     0,     0,     0,   265,
     265,   265,   265,     0,     0,     0,     0,   265,     0,   265,
     265,     0,   265,     0,     0,     0,     0,     0,     0,     0,
     265,   265,   265,   265,     0,   537,   265,   265,     0,   265,
       0,     0,     0,     0,   265,   265,   265,     0,   171,   172,
     173,   174,   265,   265,     0,     0,     0,     0,   265,     0,
     529,   530,   531,   532,     0,     0,     0,   175,     0,   572,
       0,     0,   577,   578,     0,   580,     0,     0,     0,   176,
       0,     0,     0,     0,   177,   178,     0,     0,     0,     0,
       0,     0,     0,     0,   550,   158,   159,   160,     0,     0,
       0,     0,   557,     0,     0,     0,     0,     0,   609,   610,
       0,     0,   171,   172,   173,   174,     0,     0,     0,     0,
       0,     0,     0,     0,   587,     0,     0,     0,     0,     0,
       0,   175,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   176,     0,     0,     0,   608,   177,   178,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   158,
     571,   160,     0,   294,     0,     0,   300,     0,     0,     0,
       0,     0,     0,     0,   179,   180,   181,   182,   183,   184,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   682,     0,     0,     0,     0,   657,     0,     0,
     687,   688,     0,     0,     0,   691,     0,   669,   693,     0,
       0,     0,     0,     0,     0,     0,     0,   671,   672,     0,
       0,     0,     0,   676,   677,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   683,     0,     0,   701,   179,   180,
     181,   182,   183,   184,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   697,   698,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   727,   728,     0,   729,   730,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   748,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   452,     0,   456,     0,     0,     0,     0,     0,
       0,     0,     0,   769,   770,   771,   772,     0,     0,   774,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   766,
       0,     0,     0,     0,     0,   798,   799,   800,   801,     0,
     803,   804,   805,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   810,   811,   812,   517,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   825,     0,   826,   827,
     828,     0,   830,     0,     0,     0,     0,   833,     0,     0,
       0,     0,   838,     0,     0,     0,     0,     0,     0,   816,
       0,     0,     0,     0,     0,   843,   551,   552,   844,   845,
     846,   847,   848,   849,     0,   851,   564,     0,   568,   853,
     854,     0,     0,     0,     0,     0,   579,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   859,     0,   861,     0,
       0,   863,   864,   865,     0,     0,   868,     0,     0,     0,
       0,   870,   871,   872,   873,     0,   874,   875,     0,     0,
     878,   879,   611,     0,     0,     0,     0,     0,   883,     0,
       0,     0,   885,   886,   887,   888,     0,     0,     0,     0,
     889,     0,   890,   891,     0,     0,   637,   638,     0,     0,
       0,     0,     0,   897,   898,   899,   900,     0,     0,   901,
     902,     0,     0,     0,     0,     0,     0,   905,   906,   907,
       0,     0,     0,     0,     0,   911,     0,     0,     0,     0,
       0,   914,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   674,   675,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   684,   685,   686,
       0,     0,     0,     0,     0,   689,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   702,     0,     0,     0,     0,     0,     0,     0,   709,
     710,     0,   712,     0,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   142,     0,     0,     0,
     145,     0,   148,   732,     0,     0,     0,     0,     0,   739,
       0,     0,   745,   746,     0,   166,   167,   168,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   768,     0,     0,     0,     0,   773,
       0,     0,   775,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   778,     0,     0,     0,     0,     0,     0,   785,
       0,     0,   786,     0,   788,   789,   790,   791,   792,     0,
       0,   793,     0,   794,   795,   796,     0,     0,     0,     0,
       0,   802,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     275,     0,     0,   283,     0,     0,   287,     0,     0,     0,
       0,     0,     0,   829,     0,     0,     0,     0,   832,     0,
       0,     0,     0,     0,     0,   839,     0,     0,   840,   841,
       0,     0,     0,     0,     0,   842,   206,   207,   208,   209,
     210,   211,     0,     0,     0,     0,   850,   212,     0,     0,
     338,   339,     0,     0,     0,     0,     0,     0,     0,   345,
       0,     0,     0,     0,   350,     0,     0,     0,     0,   860,
       0,     0,   862,     0,     0,     0,     0,     0,     0,   366,
       0,   869,     0,     0,     0,     0,     0,     0,     0,   376,
     377,   378,   379,     0,     0,     0,     0,     0,   387,   388,
       0,     0,   884,     0,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,     0,     0,
     227,   228,   229,   230,   896,     0,     0,   231,   232,   233,
       0,     0,     0,   234,   235,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   910,     0,     0,     0,   240,     0,
       0,     0,   913,     0,     0,     0,     0,   241,   242,   243,
       0,     0,   244,   245,     0,     0,     0,   246,     0,     0,
       0,     0,     0,     0,     0,   247,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,     0,
       0,   506,   507,     0,   510,     0,   512,     0,     0,     0,
       0,     0,     0,   519,     0,     0,     0,     0,     0,   524,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   204,     0,     0,
       0,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    -8,    -8,    -8,    -8,
      -8,    -8,     0,     0,     0,     0,     0,    -8,    -8,    -8,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    -8,     0,    -8,    -8,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   640,     0,   642,     0,     0,   645,   646,    -8,
       0,     0,     0,     0,     1,   652,   653,     0,     0,     0,
     656,     0,     0,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,     0,     0,
       0,     0,     0,     0,     0,    -8,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   704,   705,    -9,
       0,     0,     0,     0,    13,    14,    15,    16,    17,    18,
      19,    20,    21,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    22,    23,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    24,     0,    25,    -9,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    26,     0,     0,     0,     0,     6,     0,   782,
     783,     0,     0,     0,     0,     0,    27,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   797,
       0,    28,    29,     0,     0,     0,     0,    30,    31,    32,
       0,     0,     0,    33,    34,    35,     0,   806,    36,    37,
      38,    39,    40,     0,     0,     0,     0,    41,    42,    43,
      44,     0,    45,    46,    47,    48,    49,    50,    51,    52,
       0,     0,     0,    53,    54,     0,     0,    55,    56,    57,
      13,    14,    15,    16,    17,    18,    19,    20,    21,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    22,    23,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    24,     0,    25,   342,     0,     0,     0,     0,    13,
      14,    15,    16,    17,    18,    19,    20,    21,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    26,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    27,     0,     0,     0,    22,    23,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    28,    29,     0,
      24,     0,    25,    30,    31,    32,     0,     0,     0,    33,
      34,    35,     0,     0,    36,    37,    38,    39,    40,     0,
       0,     0,     0,    41,    42,    43,    44,    26,    45,    46,
      47,    48,    49,    50,    51,    52,     0,     0,     0,    53,
      54,    27,     0,    55,    56,    57,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    28,    29,     0,     0,
       0,     0,    30,    31,    32,     0,     0,     0,    33,    34,
      35,     0,     0,    36,    37,    38,    39,    40,     0,     0,
       0,     0,    41,    42,    43,    44,     0,    45,    46,    47,
      48,    49,    50,    51,    52,     0,     0,     0,    53,    54,
       0,     0,    55,    56,    57
};

static const yytype_int16 yycheck[] =
{
      39,    48,    16,    58,   151,    19,   334,   165,   258,   418,
      48,   207,   208,   209,   210,     8,    48,    88,   299,   448,
     142,    56,    55,     0,   168,    56,     1,     1,     3,    88,
     266,    56,    84,    85,    86,    14,   411,    68,    37,    38,
      39,    40,    73,    74,    61,   167,   878,    37,    38,    39,
      40,    84,    85,    86,    54,    63,    55,    56,   433,    84,
      17,    61,    70,   165,    21,    58,    56,    84,    61,    68,
     902,    70,    64,    65,    73,    74,    60,    69,    68,    84,
      70,    56,    87,    73,    74,    84,    85,    86,   165,   464,
     465,   466,   467,    68,    84,    85,    86,    44,    73,    74,
      56,   140,    49,   142,    57,   144,   145,    87,    61,    84,
      84,    85,    86,   165,    59,    51,    61,   275,   157,   277,
      56,   268,    84,    85,    86,   164,   165,   556,   167,   168,
     165,   275,   413,    51,   165,   166,   167,   168,    56,   175,
     176,   177,   178,    70,    46,    47,   185,   397,    75,   477,
     346,   347,   348,   349,    51,    52,   303,    51,    52,    57,
      46,    47,   201,    61,   163,   164,   165,   166,   167,   168,
      84,    85,    86,   163,   164,   165,   166,   167,   168,    76,
      77,    57,    76,    77,    84,    61,   333,    67,    68,    84,
     165,   166,   167,   168,    37,    38,    39,    40,    56,    74,
      80,    81,    82,    84,    44,    84,    46,    47,   366,    49,
      68,    84,    55,    56,    50,    73,    74,   253,    90,   266,
     256,   257,    78,    79,   271,    68,    61,    62,   266,    87,
      73,    74,   271,   271,   266,    60,   275,   276,   277,    91,
     649,    84,    85,    86,   283,    92,   285,    92,   284,    56,
     289,   290,    67,    68,    56,    44,   141,    46,    47,    48,
      49,    56,   301,   302,   242,   243,    68,   254,   255,   305,
      84,    73,    74,    46,    47,    48,   161,   582,   583,   529,
     530,   428,   470,   471,   472,    87,   462,   463,   343,   485,
     486,   487,   488,    22,    23,    24,    25,    26,   165,   338,
     339,   340,    84,    85,    86,    96,   681,   165,   166,   167,
     168,   468,   469,    87,    92,    96,    92,    84,    84,    18,
     163,   164,   165,   166,   167,   168,    66,   366,    92,    21,
      56,   165,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   491,   492,    56,
     343,    93,   165,    36,    60,   391,   392,   393,   394,    92,
      92,   519,   376,   165,   166,   167,   168,     4,    92,    60,
      92,   418,     4,     4,   388,   411,    29,   416,   263,    89,
     418,   756,    60,    45,    19,    19,   418,   762,    57,   425,
      19,    19,    17,   278,    61,    60,    60,   433,    56,   162,
     439,    51,   441,   442,   275,   165,    61,   292,   293,    61,
     295,   661,   662,    51,    56,    71,    57,   166,    72,   455,
     616,   617,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
      84,    51,   478,   166,   165,    60,   165,    60,    84,   824,
      27,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,    56,   703,   704,   705,
      92,   510,   708,   512,    92,   165,   165,   621,    68,   623,
     519,    19,    58,    73,    74,   524,   165,    57,   165,    53,
      56,    56,   528,    61,    57,   366,    56,   165,   537,    56,
      59,    57,   538,    28,   165,   649,    37,    38,    39,    40,
      60,   747,   548,   549,   165,    20,   165,   165,   554,   555,
     895,   668,   407,    84,    57,   165,   165,    57,    52,   565,
      57,    57,   165,    61,    92,   165,    16,    84,   165,    70,
      62,   165,   165,    66,   780,   781,   782,   783,   165,   585,
     586,    57,    54,    84,    85,    86,   441,    51,    54,   444,
     445,   165,   447,    15,    57,    57,    57,    52,   818,   713,
      57,    61,    51,   163,   164,   165,   166,   167,   168,    52,
      52,    95,   621,    61,   623,    52,    94,   483,   202,   205,
     532,   136,   758,   287,   167,   480,   481,   302,   375,   649,
     836,   837,   176,   642,   176,   431,   645,   646,   145,   405,
     649,   700,   460,   459,   458,   193,    -1,   656,    -1,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   461,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   680,   681,    -1,    -1,   519,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   703,   704,   705,    -1,
      -1,   708,    -1,    -1,   700,   703,   704,   705,    -1,    -1,
     708,   703,   704,   705,   713,    -1,   708,    -1,    -1,   564,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   572,   573,    -1,
      -1,    -1,   577,    -1,    -1,   580,    -1,    -1,    -1,    -1,
     747,    -1,    -1,    -1,    -1,    -1,   745,   746,    -1,   747,
      -1,    -1,    -1,    -1,   750,   747,    -1,    -1,    -1,    -1,
     756,    -1,    -1,    -1,   609,    -1,   762,    -1,    -1,    -1,
      -1,    -1,    -1,   780,   781,   782,   783,    -1,    -1,   141,
      -1,    -1,   780,   781,   782,   783,    -1,    -1,   780,   781,
     782,   783,   637,   638,    -1,   640,   641,    -1,    -1,   161,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   808,
     655,    -1,    -1,    -1,    -1,    -1,    37,    38,    39,    40,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   824,   836,
     837,    -1,    -1,    -1,    55,    56,    -1,    -1,   836,   837,
     685,   686,   687,   688,   836,   837,   691,    68,    -1,    -1,
      -1,   850,    73,    74,    -1,    -1,   855,    -1,    -1,    -1,
      -1,    -1,    -1,    84,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   876,    -1,    -1,
      -1,    -1,   727,   728,   729,   730,    -1,   732,   733,   734,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   895,
      -1,   263,   747,   748,   749,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   278,    -1,    -1,    -1,
      -1,    -1,    -1,   768,    -1,   770,   771,   772,    -1,   774,
     292,   293,   253,   295,   779,   256,   257,    -1,    -1,   784,
      -1,    -1,   163,   164,   165,   166,   167,   168,    -1,    -1,
      -1,    -1,   797,    -1,    -1,   800,   801,   802,   803,   804,
     805,    -1,   807,   284,    -1,    -1,   811,   812,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,    -1,    -1,   828,    -1,   830,    -1,    -1,   833,   834,
     835,    -1,    -1,   838,    -1,   240,    -1,    -1,   843,   844,
     845,   846,    -1,   848,   849,    -1,    -1,   852,   853,    -1,
      -1,    -1,    -1,    -1,    -1,   860,    -1,    -1,    -1,   864,
     865,   866,   867,    -1,    -1,    -1,    -1,   872,    -1,   874,
     875,    -1,   877,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     885,   886,   887,   888,    -1,   407,   891,   892,    -1,   894,
      -1,    -1,    -1,    -1,   899,   900,   901,    -1,    37,    38,
      39,    40,   907,   908,    -1,    -1,    -1,    -1,   913,    -1,
     391,   392,   393,   394,    -1,    -1,    -1,    56,    -1,   441,
      -1,    -1,   444,   445,    -1,   447,    -1,    -1,    -1,    68,
      -1,    -1,    -1,    -1,    73,    74,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   425,    84,    85,    86,    -1,    -1,
      -1,    -1,   433,    -1,    -1,    -1,    -1,    -1,   480,   481,
      -1,    -1,    37,    38,    39,    40,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   455,    -1,    -1,    -1,    -1,    -1,
      -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    68,    -1,    -1,    -1,   478,    73,    74,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,
      85,    86,    -1,   163,    -1,    -1,   166,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   163,   164,   165,   166,   167,   168,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   564,    -1,    -1,    -1,    -1,   528,    -1,    -1,
     572,   573,    -1,    -1,    -1,   577,    -1,   538,   580,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   548,   549,    -1,
      -1,    -1,    -1,   554,   555,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   565,    -1,    -1,   609,   163,   164,
     165,   166,   167,   168,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   585,   586,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   637,   638,    -1,   640,   641,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   655,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   302,    -1,   304,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   685,   686,   687,   688,    -1,    -1,   691,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   680,
      -1,    -1,    -1,    -1,    -1,   727,   728,   729,   730,    -1,
     732,   733,   734,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   747,   748,   749,   378,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   768,    -1,   770,   771,
     772,    -1,   774,    -1,    -1,    -1,    -1,   779,    -1,    -1,
      -1,    -1,   784,    -1,    -1,    -1,    -1,    -1,    -1,   750,
      -1,    -1,    -1,    -1,    -1,   797,   426,   427,   800,   801,
     802,   803,   804,   805,    -1,   807,   436,    -1,   438,   811,
     812,    -1,    -1,    -1,    -1,    -1,   446,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   828,    -1,   830,    -1,
      -1,   833,   834,   835,    -1,    -1,   838,    -1,    -1,    -1,
      -1,   843,   844,   845,   846,    -1,   848,   849,    -1,    -1,
     852,   853,   482,    -1,    -1,    -1,    -1,    -1,   860,    -1,
      -1,    -1,   864,   865,   866,   867,    -1,    -1,    -1,    -1,
     872,    -1,   874,   875,    -1,    -1,   506,   507,    -1,    -1,
      -1,    -1,    -1,   885,   886,   887,   888,    -1,    -1,   891,
     892,    -1,    -1,    -1,    -1,    -1,    -1,   899,   900,   901,
      -1,    -1,    -1,    -1,    -1,   907,    -1,    -1,    -1,    -1,
      -1,   913,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   551,   552,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   567,   568,   569,
      -1,    -1,    -1,    -1,    -1,   575,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   611,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   619,
     620,    -1,   622,    -1,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,    23,    -1,    -1,    -1,
      27,    -1,    29,   643,    -1,    -1,    -1,    -1,    -1,   649,
      -1,    -1,   652,   653,    -1,    42,    43,    44,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   684,    -1,    -1,    -1,    -1,   689,
      -1,    -1,   692,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   702,    -1,    -1,    -1,    -1,    -1,    -1,   709,
      -1,    -1,   712,    -1,   714,   715,   716,   717,   718,    -1,
      -1,   721,    -1,   723,   724,   725,    -1,    -1,    -1,    -1,
      -1,   731,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     147,    -1,    -1,   150,    -1,    -1,   153,    -1,    -1,    -1,
      -1,    -1,    -1,   773,    -1,    -1,    -1,    -1,   778,    -1,
      -1,    -1,    -1,    -1,    -1,   785,    -1,    -1,   788,   789,
      -1,    -1,    -1,    -1,    -1,   795,    30,    31,    32,    33,
      34,    35,    -1,    -1,    -1,    -1,   806,    41,    -1,    -1,
     197,   198,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   206,
      -1,    -1,    -1,    -1,   211,    -1,    -1,    -1,    -1,   829,
      -1,    -1,   832,    -1,    -1,    -1,    -1,    -1,    -1,   226,
      -1,   841,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   236,
     237,   238,   239,    -1,    -1,    -1,    -1,    -1,   245,   246,
      -1,    -1,   862,    -1,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,    -1,    -1,
     114,   115,   116,   117,   884,    -1,    -1,   121,   122,   123,
      -1,    -1,    -1,   127,   128,    -1,    -1,    -1,    -1,    -1,
     134,   135,   136,   137,   904,    -1,    -1,    -1,   142,    -1,
      -1,    -1,   912,    -1,    -1,    -1,    -1,   151,   152,   153,
      -1,    -1,   156,   157,    -1,    -1,    -1,   161,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
      -1,   368,   369,    -1,   371,    -1,   373,    -1,    -1,    -1,
      -1,    -1,    -1,   380,    -1,    -1,    -1,    -1,    -1,   386,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,    -1,
      -1,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    30,    31,    32,    33,
      34,    35,    -1,    -1,    -1,    -1,    -1,    41,    42,    43,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    56,    -1,    58,    59,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   509,    -1,   511,    -1,    -1,   514,   515,    83,
      -1,    -1,    -1,    -1,    88,   522,   523,    -1,    -1,    -1,
     527,    -1,    -1,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   614,   615,     0,
      -1,    -1,    -1,    -1,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    42,    43,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    56,    -1,    58,    59,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    83,    -1,    -1,    -1,    -1,    88,    -1,   706,
     707,    -1,    -1,    -1,    -1,    -1,    97,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   726,
      -1,   112,   113,    -1,    -1,    -1,    -1,   118,   119,   120,
      -1,    -1,    -1,   124,   125,   126,    -1,   744,   129,   130,
     131,   132,   133,    -1,    -1,    -1,    -1,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,   147,   148,   149,   150,
      -1,    -1,    -1,   154,   155,    -1,    -1,   158,   159,   160,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    42,    43,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    56,    -1,    58,    59,    -1,    -1,    -1,    -1,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    83,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    97,    -1,    -1,    -1,    42,    43,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   112,   113,    -1,
      56,    -1,    58,   118,   119,   120,    -1,    -1,    -1,   124,
     125,   126,    -1,    -1,   129,   130,   131,   132,   133,    -1,
      -1,    -1,    -1,   138,   139,   140,   141,    83,   143,   144,
     145,   146,   147,   148,   149,   150,    -1,    -1,    -1,   154,
     155,    97,    -1,   158,   159,   160,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   112,   113,    -1,    -1,
      -1,    -1,   118,   119,   120,    -1,    -1,    -1,   124,   125,
     126,    -1,    -1,   129,   130,   131,   132,   133,    -1,    -1,
      -1,    -1,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,   147,   148,   149,   150,    -1,    -1,    -1,   154,   155,
      -1,    -1,   158,   159,   160
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,    88,   171,   174,   175,     0,    88,    14,   172,   183,
     165,   175,    60,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    42,    43,    56,    58,    83,    97,   112,   113,
     118,   119,   120,   124,   125,   126,   129,   130,   131,   132,
     133,   138,   139,   140,   141,   143,   144,   145,   146,   147,
     148,   149,   150,   154,   155,   158,   159,   160,   173,   176,
     177,   178,   181,   182,   184,   185,   186,   187,   188,   189,
     191,   192,   193,   196,   197,   198,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   229,
     230,   231,   232,   233,   234,   235,   237,   238,   239,   242,
     243,   245,   246,   248,   250,   251,   252,   253,   254,   257,
     258,   259,   260,   261,   262,   263,   264,   266,   165,    84,
      84,    87,   180,    87,   180,    84,    84,   180,    84,    84,
      56,   313,   313,    74,   267,   313,    50,   271,   313,    91,
     265,    90,    60,   312,    92,    92,    56,   284,    84,    85,
      86,   315,   316,    56,   285,    84,   313,   313,   313,    87,
     165,    37,    38,    39,    40,    56,    68,    73,    74,   163,
     164,   165,   166,   167,   168,   270,   278,   282,   298,   299,
     300,   301,   315,   328,   329,    96,    96,    92,    92,    84,
      84,    92,   174,   175,     1,   175,    30,    31,    32,    33,
      34,    35,    41,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   114,   115,   116,
     117,   121,   122,   123,   127,   128,   134,   135,   136,   137,
     142,   151,   152,   153,   156,   157,   161,   169,    22,    23,
      24,    25,    26,    18,   194,   194,    66,    21,   195,   165,
     314,   315,    85,   288,   289,   316,   273,   293,   315,   308,
     315,   272,   292,   310,   315,   313,    55,   270,   277,   282,
     299,   302,   306,   313,    56,   307,   165,   313,    56,   311,
      93,   165,   315,   288,   277,   315,   274,   293,   294,   306,
     277,   273,   287,   315,   308,    68,   165,   166,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     166,   300,   301,   328,   328,   328,    46,    47,    46,    47,
      48,    56,    84,   315,   307,    44,    49,   331,   313,   313,
     315,   176,    59,   173,   179,   313,   312,   312,   312,   312,
     313,    36,   269,   269,   269,   269,   269,   269,   269,   269,
     269,   269,   269,   269,   269,   269,   313,    60,    92,    92,
       4,    92,    60,    92,     4,     4,   313,   313,   313,   313,
     269,    29,   244,   244,   244,    89,   249,   313,   313,    60,
      45,    19,    19,    19,    19,   317,    17,   195,   204,   195,
      87,   317,   317,   204,    57,    61,    60,   288,    60,   290,
     278,    51,   303,   307,   162,   268,    70,   280,   281,   282,
     295,   296,   297,   310,   315,    56,   274,   308,   315,   309,
     315,   306,   288,    51,   304,   305,   315,   317,   315,   265,
     165,   315,   315,    61,   288,   288,    61,   288,   303,    56,
     286,   315,   277,   286,   315,    56,   277,    57,    70,    75,
      71,    72,    78,    79,    51,    52,    76,    77,    67,    68,
      80,    81,    82,    64,    65,    69,    84,   307,    51,   304,
     315,   315,   315,   175,   166,   312,   312,   312,   312,   166,
     313,   313,   313,   313,   313,   313,   313,   313,   313,   313,
     313,   313,   313,   313,   274,   165,   313,   313,    60,   255,
     313,   165,   313,    60,   236,   236,   180,   277,    84,   313,
      27,   240,    92,    92,   313,   165,   180,   165,    19,   317,
     317,   317,   317,    58,   204,   314,   165,   288,    56,   165,
     324,   303,    57,   315,   279,   282,   295,   299,    53,    56,
     317,   277,   277,    54,    61,    56,   305,   317,   324,    46,
      47,    48,   330,   331,   277,    61,   165,   228,   277,   315,
      57,    85,   288,   315,   316,   315,   165,   288,   288,   277,
     288,   330,    61,    84,   256,    56,    56,   317,   320,   319,
     321,   322,   323,   323,   324,   324,   324,   324,   327,   327,
     326,   326,   326,   328,   328,   328,    57,   304,   317,   288,
     288,   277,   179,   165,   312,   312,   312,   312,   165,   274,
     274,   308,   274,   308,   274,   274,   274,   274,   274,   274,
     274,   274,   274,   274,   274,   274,    60,   277,   277,   165,
     313,   315,   313,   315,   165,   313,   313,   165,   165,   274,
      28,   241,   313,   313,   315,   165,   313,   317,   204,   204,
      20,   190,   190,    84,   202,   203,    57,   283,   315,   317,
      52,   317,   317,    57,   277,   277,   317,   317,   330,    61,
      62,    52,   288,   317,   277,   277,   277,   288,   288,   277,
      57,   288,    61,   288,   256,   256,    57,   317,   317,    57,
      63,   288,   277,   165,   313,   313,   312,   312,   165,   277,
     277,   308,   277,   308,   277,   277,   277,   277,   277,   277,
     277,   277,   277,   277,   277,   277,   165,   288,   288,   288,
     288,   315,   277,   315,   315,   165,   165,   275,   276,   277,
     295,   297,   308,   315,    92,   277,   277,   247,   288,   315,
      16,   199,   200,    84,   204,   204,    66,    59,    61,   307,
      57,    54,    51,    54,    57,   165,   317,    57,   277,   288,
     288,   288,   288,   277,   288,   277,    57,   318,   277,   278,
     278,   278,   313,   313,   278,   277,   277,   308,   277,   277,
     277,   277,   277,   277,   277,   277,   277,   313,   288,   288,
     288,   288,   277,   288,   288,   288,   313,   315,   315,   278,
     288,   288,   288,     1,     3,    84,   317,    15,   201,    87,
     324,   202,   324,    52,    61,   288,   288,   288,   288,   277,
     288,    57,   277,   288,   278,   278,   278,   278,   288,   277,
     277,   277,   277,   288,   288,   288,   288,   288,   288,   288,
     277,   288,   315,   288,   288,    51,   204,    52,   324,   288,
     277,   288,   277,   288,   288,   288,   278,   278,   288,   277,
     288,   288,   288,   288,   288,   288,   315,   291,   288,   288,
       1,   315,    52,   288,   277,   288,   288,   288,   288,   288,
     288,   288,   315,   288,   291,    61,   277,   288,   288,   288,
     288,   288,   288,   324,    95,   288,   288,   288,   291,    52,
     277,   288,    94,   277,   288
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   170,   171,   172,   173,   173,   174,   174,   175,   175,
     176,   176,   176,   176,   176,   176,   176,   176,   176,   176,
     176,   177,   177,   177,   178,   179,   180,   180,   181,   182,
     183,   184,   184,   184,   184,   184,   184,   185,   186,   187,
     188,   189,   190,   190,   191,   192,   192,   193,   193,   194,
     194,   195,   196,   197,   197,   197,   197,   198,   199,   199,
     200,   200,   200,   200,   201,   201,   201,   202,   202,   202,
     203,   203,   204,   204,   205,   205,   205,   205,   205,   205,
     205,   205,   205,   205,   205,   205,   205,   205,   205,   205,
     205,   205,   205,   205,   205,   205,   205,   205,   205,   205,
     205,   205,   205,   205,   205,   205,   205,   205,   205,   205,
     205,   205,   205,   205,   205,   205,   205,   205,   205,   205,
     205,   205,   205,   206,   207,   207,   207,   207,   208,   208,
     209,   210,   211,   212,   213,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   224,   225,   225,
     225,   226,   226,   227,   227,   228,   229,   230,   231,   232,
     233,   233,   233,   234,   235,   236,   236,   237,   238,   238,
     239,   240,   240,   241,   241,   242,   243,   244,   244,   245,
     246,   247,   247,   247,   248,   249,   249,   250,   251,   252,
     252,   252,   253,   254,   254,   254,   254,   254,   255,   255,
     256,   256,   256,   257,   257,   257,   257,   257,   257,   257,
     258,   259,   260,   260,   261,   262,   263,   263,   263,   263,
     264,   264,   264,   264,   264,   264,   264,   264,   265,   265,
     266,   266,   267,   267,   268,   268,   269,   269,   270,   270,
     270,   270,   271,   271,   272,   273,   274,   274,   275,   275,
     276,   276,   277,   277,   277,   278,   278,   279,   279,   279,
     280,   280,   281,   281,   282,   283,   284,   285,   286,   287,
     288,   288,   289,   290,   290,   291,   291,   292,   293,   293,
     294,   295,   295,   296,   297,   298,   298,   299,   299,   299,
     299,   299,   299,   300,   300,   300,   301,   301,   301,   302,
     302,   303,   304,   305,   305,   305,   306,   306,   307,   308,
     309,   310,   311,   311,   312,   313,   313,   314,   315,   315,
     316,   316,   317,   318,   318,   319,   319,   320,   320,   321,
     321,   322,   322,   322,   323,   323,   323,   323,   323,   324,
     325,   325,   325,   325,   326,   326,   326,   327,   327,   327,
     327,   328,   328,   328,   328,   329,   329,   329,   329,   329,
     329,   330,   330,   330,   330,   331,   331
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     5,     1,     3,     1,     2,     1,     0,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     5,     2,     1,     1,     1,     1,     2,     2,
       4,     1,     1,     1,     1,     1,     1,     2,     9,     6,
       6,     7,     0,     2,     7,     4,     3,     5,     4,     0,
       2,     2,     4,     4,     4,     2,     3,     2,     0,     1,
       2,     2,     2,     2,     0,     6,     3,     3,     3,     1,
       3,     1,     0,     4,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     7,     7,     8,     9,     6,     6,
       6,     7,     6,     7,     8,     7,     6,     8,     8,     4,
       6,     5,     4,     7,     7,     7,     6,     6,     4,     4,
       4,     6,     6,     8,     7,     1,     8,    10,     8,     9,
       1,     1,     1,    10,    13,     0,     2,    10,     9,     8,
      12,     0,     1,     0,     1,     9,    10,     0,     1,     6,
       5,     0,     2,     2,     6,     0,     1,     9,    16,     9,
       5,     6,     6,     4,     9,     9,     7,     7,     0,     2,
       0,     2,     2,     4,     4,     3,     6,     6,     6,     3,
       2,     2,     9,     9,     2,     2,    12,    12,    11,    11,
       1,     2,     1,     1,     2,     1,     2,     1,     0,     1,
       0,     5,     0,     1,     0,     1,     0,     1,     1,     1,
       1,     1,     0,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     5,     7,     4,     4,
       1,     3,     2,     2,     4,     0,     2,     1,     3,     2,
       3,     1,     4,     2,     1,     3,     4,     2,     2,     1,
       2,     1,     2,     1,     2,     2,     1,     2,     2,     3,
       4,     3,     7,     1,     5,     3,     5,     3,     5,     1,
       4,     7,     0,     3,     2,     3,     5,     1,     1,     1,
       1,     1,     1,     5,     1,     3,     1,     3,     1,     3,
       1,     3,     3,     1,     3,     3,     3,     3,     1,     1,
       3,     3,     3,     1,     3,     3,     1,     3,     3,     3,
       1,     2,     2,     2,     1,     1,     1,     3,     2,     4,
       1,     1,     1,     1,     1,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (pBuilder, YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, pBuilder); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, CISA_IR_Builder* pBuilder)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  YYUSE (pBuilder);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, CISA_IR_Builder* pBuilder)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep, pBuilder);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule, CISA_IR_Builder* pBuilder)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              , pBuilder);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule, pBuilder); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, CISA_IR_Builder* pBuilder)
{
  YYUSE (yyvaluep);
  YYUSE (pBuilder);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (CISA_IR_Builder* pBuilder)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex (pBuilder);
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 519 "CISA.y" /* yacc.c:1646  */
    {
        TRACE("** Listing Complete\n");
        pBuilder->CISA_post_file_parse();
    }
#line 2606 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 23:
#line 549 "CISA.y" /* yacc.c:1646  */
    {
        PARSE_ERROR_AT((int)(yyvsp[-1].intval), "unclosed scope");
    }
#line 2614 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 24:
#line 553 "CISA.y" /* yacc.c:1646  */
    {
        pBuilder->CISA_push_decl_scope();
        (yyval.intval) = CISAlineno;
    }
#line 2623 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 25:
#line 557 "CISA.y" /* yacc.c:1646  */
    {pBuilder->CISA_pop_decl_scope();}
#line 2629 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 28:
#line 568 "CISA.y" /* yacc.c:1646  */
    {
        VISAKernel *cisa_kernel = NULL;
        pBuilder->AddKernel(cisa_kernel, (yyvsp[0].string));
    }
#line 2638 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 29:
#line 576 "CISA.y" /* yacc.c:1646  */
    {
      VISAFunction *cisa_kernel = NULL;
      pBuilder->AddFunction(cisa_kernel, (yyvsp[0].string));
  }
#line 2647 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 30:
#line 584 "CISA.y" /* yacc.c:1646  */
    {
       pBuilder->CISA_IR_setVersion((unsigned char)(yyvsp[-2].intval), (unsigned char)(yyvsp[0].intval));
   }
#line 2655 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 37:
#line 598 "CISA.y" /* yacc.c:1646  */
    {
        // do nothing as it's informational only
    }
#line 2663 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 38:
#line 605 "CISA.y" /* yacc.c:1646  */
    {
       ABORT_ON_FAIL(pBuilder->CISA_general_variable_decl(
           (yyvsp[-7].string), (unsigned int)(yyvsp[-3].intval), (yyvsp[-5].type), (yyvsp[-2].align), (yyvsp[-1].alias).aliasname, (yyvsp[-1].alias).offset, AttrOptVar, CISAlineno));
       AttrOptVar.clear();
    }
#line 2673 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 39:
#line 613 "CISA.y" /* yacc.c:1646  */
    {
       ABORT_ON_FAIL(
           pBuilder->CISA_addr_variable_decl((yyvsp[-4].string), (unsigned int)(yyvsp[-1].intval), ISA_TYPE_UW, AttrOptVar, CISAlineno));
       AttrOptVar.clear();
   }
#line 2683 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 40:
#line 621 "CISA.y" /* yacc.c:1646  */
    {
       ABORT_ON_FAIL(pBuilder->CISA_predicate_variable_decl((yyvsp[-4].string), (unsigned int)(yyvsp[-1].intval), AttrOptVar, CISAlineno));
       AttrOptVar.clear();
   }
#line 2692 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 41:
#line 628 "CISA.y" /* yacc.c:1646  */
    {
       ABORT_ON_FAIL(pBuilder->CISA_sampler_variable_decl((yyvsp[-5].string), (int)(yyvsp[-2].intval), (yyvsp[-1].string), CISAlineno));
   }
#line 2700 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 42:
#line 631 "CISA.y" /* yacc.c:1646  */
    {(yyval.string) = "";}
#line 2706 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 43:
#line 631 "CISA.y" /* yacc.c:1646  */
    {(yyval.string) = (yyvsp[0].string);}
#line 2712 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 44:
#line 635 "CISA.y" /* yacc.c:1646  */
    {
       ABORT_ON_FAIL(pBuilder->CISA_surface_variable_decl((yyvsp[-5].string), (int)(yyvsp[-2].intval), (yyvsp[-1].string), AttrOptVar, CISAlineno));
       AttrOptVar.clear();
   }
#line 2721 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 45:
#line 643 "CISA.y" /* yacc.c:1646  */
    {
        ABORT_ON_FAIL(pBuilder->CISA_input_directive((yyvsp[-2].string), (short)(yyvsp[-1].intval), (unsigned short)(yyvsp[0].intval), CISAlineno));
    }
#line 2729 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 46:
#line 648 "CISA.y" /* yacc.c:1646  */
    {
        int64_t size = 0;
        ABORT_ON_FAIL(pBuilder->CISA_eval_sizeof_decl(CISAlineno, (yyvsp[-1].string), size));
        MUST_HOLD(size < 0x10000, "declaration size is too large");
        ABORT_ON_FAIL(pBuilder->CISA_input_directive((yyvsp[-1].string), (short)(yyvsp[0].intval), (unsigned short)size, CISAlineno));
    }
#line 2740 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 47:
#line 660 "CISA.y" /* yacc.c:1646  */
    {
        ABORT_ON_FAIL(pBuilder->CISA_implicit_input_directive(
            (yyvsp[-4].string), (yyvsp[-3].string), (short)(yyvsp[-2].intval), (unsigned short)(yyvsp[-1].intval), CISAlineno));
    }
#line 2749 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 48:
#line 667 "CISA.y" /* yacc.c:1646  */
    {
        int64_t size = 0;
        ABORT_ON_FAIL(pBuilder->CISA_eval_sizeof_decl(CISAlineno, (yyvsp[-2].string), size));
        MUST_HOLD(size < 0x10000, "declaration size is too large");
        ABORT_ON_FAIL(pBuilder->CISA_input_directive((yyvsp[-2].string), (short)(yyvsp[-1].intval), (unsigned short)size, CISAlineno));
    }
#line 2760 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 49:
#line 674 "CISA.y" /* yacc.c:1646  */
    {(yyval.intval) = 0;}
#line 2766 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 50:
#line 674 "CISA.y" /* yacc.c:1646  */
    {(yyval.intval) = (yyvsp[0].intval);}
#line 2772 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 51:
#line 675 "CISA.y" /* yacc.c:1646  */
    {(yyval.intval) = (yyvsp[0].intval);}
#line 2778 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 52:
#line 682 "CISA.y" /* yacc.c:1646  */
    {
        ABORT_ON_FAIL(pBuilder->CISA_input_directive((yyvsp[-2].string), 0, (unsigned short)(yyvsp[-1].intval), CISAlineno));
    }
#line 2786 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 53:
#line 688 "CISA.y" /* yacc.c:1646  */
    {
        ABORT_ON_FAIL(pBuilder->CISA_attr_directive((yyvsp[-2].string), (yyvsp[0].string), CISAlineno));
    }
#line 2794 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 54:
#line 692 "CISA.y" /* yacc.c:1646  */
    {
        ABORT_ON_FAIL(pBuilder->CISA_attr_directiveNum((yyvsp[-2].string), (uint32_t)(yyvsp[0].intval), CISAlineno));
    }
#line 2802 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 55:
#line 696 "CISA.y" /* yacc.c:1646  */
    {
        ABORT_ON_FAIL(pBuilder->CISA_attr_directive((yyvsp[0].string), nullptr, CISAlineno));
    }
#line 2810 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 56:
#line 700 "CISA.y" /* yacc.c:1646  */
    {
        ABORT_ON_FAIL(pBuilder->CISA_attr_directive((yyvsp[-1].string), nullptr, CISAlineno));
    }
#line 2818 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 57:
#line 706 "CISA.y" /* yacc.c:1646  */
    {
        ABORT_ON_FAIL(pBuilder->CISA_function_directive((yyvsp[0].string), CISAlineno));
    }
#line 2826 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 58:
#line 711 "CISA.y" /* yacc.c:1646  */
    {(yyval.align) = ALIGN_BYTE;}
#line 2832 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 60:
#line 713 "CISA.y" /* yacc.c:1646  */
    { // 2GRF, 32word, ...
        (yyval.align) = (yyvsp[0].align);
    }
#line 2840 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 61:
#line 717 "CISA.y" /* yacc.c:1646  */
    { // e.g. byte, word, dword, qword, GRF, GRFx2
       if (!ParseAlign(pBuilder, (yyvsp[0].string), (yyval.align))) {
           PARSE_ERROR((yyvsp[0].string), ": invalid align value");
       }
    }
#line 2850 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 62:
#line 723 "CISA.y" /* yacc.c:1646  */
    {
        // e.g. %sizeof(GRF) or %sizeof(DECL)
        (yyval.align) = AlignBytesToVisaAlignment((int)(yyvsp[0].intval));
        if ((yyval.align) == ALIGN_UNDEF) {
            PARSE_ERROR("invalid align size (must be 1, 2, 4, 8, ..., 128)");
        }
    }
#line 2862 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 63:
#line 731 "CISA.y" /* yacc.c:1646  */
    {
        PARSE_ERROR("syntax error in align attribute");
    }
#line 2870 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 64:
#line 738 "CISA.y" /* yacc.c:1646  */
    {
       (yyval.alias).aliasname = NULL;
       (yyval.alias).offset = 0;
    }
#line 2879 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 65:
#line 743 "CISA.y" /* yacc.c:1646  */
    {
       (yyval.alias).aliasname = (yyvsp[-3].string);
       (yyval.alias).offset = (int)(yyvsp[-1].intval);
    }
#line 2888 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 66:
#line 748 "CISA.y" /* yacc.c:1646  */
    {
       PARSE_ERROR("syntax error in alias attribute");
    }
#line 2896 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 67:
#line 754 "CISA.y" /* yacc.c:1646  */
    {
      (yyval.pattr_gen) = pBuilder->CISA_Create_Attr((yyvsp[-2].string), (yyvsp[0].intval), nullptr);
    }
#line 2904 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 68:
#line 758 "CISA.y" /* yacc.c:1646  */
    {
      (yyval.pattr_gen) = pBuilder->CISA_Create_Attr((yyvsp[-2].string), 0, (yyvsp[0].string));
    }
#line 2912 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 69:
#line 762 "CISA.y" /* yacc.c:1646  */
    {
      (yyval.pattr_gen) = pBuilder->CISA_Create_Attr((yyvsp[0].string), 0, nullptr);
    }
#line 2920 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 70:
#line 768 "CISA.y" /* yacc.c:1646  */
    {
      AttrOptVar.push_back((yyvsp[0].pattr_gen));
    }
#line 2928 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 71:
#line 773 "CISA.y" /* yacc.c:1646  */
    {
      AttrOptVar.push_back((yyvsp[0].pattr_gen));
    }
#line 2936 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 72:
#line 779 "CISA.y" /* yacc.c:1646  */
    {
        (yyval.intval) = 0;
    }
#line 2944 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 73:
#line 783 "CISA.y" /* yacc.c:1646  */
    {
        (yyval.intval) = 1;
    }
#line 2952 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 123:
#line 843 "CISA.y" /* yacc.c:1646  */
    {pBuilder->CISA_create_label((yyvsp[0].string), CISAlineno);}
#line 2958 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 124:
#line 848 "CISA.y" /* yacc.c:1646  */
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-6].pred_reg), (yyvsp[-5].opcode), (yyvsp[-4].sat), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, NULL, CISAlineno);
    }
#line 2967 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 125:
#line 854 "CISA.y" /* yacc.c:1646  */
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-5].opcode), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, (yyvsp[-2].vISADecl), (yyvsp[-1].vISADecl), (yyvsp[0].vISADecl), CISAlineno);
    }
#line 2975 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 126:
#line 859 "CISA.y" /* yacc.c:1646  */
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-7].pred_reg), (yyvsp[-6].opcode), (yyvsp[-5].sat), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, CISAlineno);
    }
#line 2984 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 127:
#line 865 "CISA.y" /* yacc.c:1646  */
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-8].pred_reg), (yyvsp[-7].opcode), (yyvsp[-6].sat), (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size,
            (yyvsp[-4].genOperand).cisa_gen_opnd, (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 2993 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 128:
#line 873 "CISA.y" /* yacc.c:1646  */
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, NULL, NULL, CISAlineno);
    }
#line 3002 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 129:
#line 879 "CISA.y" /* yacc.c:1646  */
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-4].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].vISADecl), (yyvsp[0].vISADecl), NULL, CISAlineno);
    }
#line 3011 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 130:
#line 886 "CISA.y" /* yacc.c:1646  */
    {
        pBuilder->CISA_create_math_instruction((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, CISAlineno);
    }
#line 3020 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 131:
#line 893 "CISA.y" /* yacc.c:1646  */
    {
        pBuilder->CISA_create_math_instruction((yyvsp[-6].pred_reg), (yyvsp[-5].opcode), (yyvsp[-4].sat), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3029 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 132:
#line 900 "CISA.y" /* yacc.c:1646  */
    {
        pBuilder->CISA_create_arith_instruction((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, NULL, CISAlineno);
    }
#line 3038 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 133:
#line 907 "CISA.y" /* yacc.c:1646  */
    {
        MUST_HOLD(!(((yyvsp[-5].opcode) == ISA_LINE) && ((yyvsp[-1].genOperand).type == OPERAND_IMMEDIATE || (yyvsp[-1].genOperand).type == OPERAND_INDIRECT)),
            "wrong type of src0 operand");
        pBuilder->CISA_create_arith_instruction(
            (yyvsp[-6].pred_reg), (yyvsp[-5].opcode), (yyvsp[-4].sat), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, CISAlineno);
    }
#line 3050 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 134:
#line 918 "CISA.y" /* yacc.c:1646  */
    {
         pBuilder->CISA_create_arith_instruction((yyvsp[-7].pred_reg), (yyvsp[-6].opcode), (yyvsp[-5].sat), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
     }
#line 3059 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 135:
#line 925 "CISA.y" /* yacc.c:1646  */
    {
        pBuilder->CISA_create_arith_instruction2((yyvsp[-6].pred_reg), (yyvsp[-5].opcode), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
     }
#line 3068 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 136:
#line 934 "CISA.y" /* yacc.c:1646  */
    {
        pBuilder->CISA_create_dpas_instruction(
            (yyvsp[-5].dpas_info).opcode, (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].genOperand).cisa_gen_opnd,
            (yyvsp[-5].dpas_info).src2Precision, (yyvsp[-5].dpas_info).src1Precision, (yyvsp[-5].dpas_info).depth, (yyvsp[-5].dpas_info).count, CISAlineno);
    }
#line 3079 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 137:
#line 944 "CISA.y" /* yacc.c:1646  */
    {
        pBuilder->CISA_create_bfn_instruction((yyvsp[-7].pred_reg), (yyvsp[-6].bfn_info).func_ctrl , (yyvsp[-5].sat), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3088 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 138:
#line 950 "CISA.y" /* yacc.c:1646  */
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_qword_scatter_instruction(
            (yyvsp[-6].opcode), (yyvsp[-7].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, (uint32_t)(yyvsp[-4].intval), (yyvsp[-2].string), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3097 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 139:
#line 957 "CISA.y" /* yacc.c:1646  */
    {
        pBuilder->CISA_create_bf_cvt_instruction((yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3105 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 140:
#line 964 "CISA.y" /* yacc.c:1646  */
    {
        pBuilder->CISA_create_invtri_inst((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3114 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 141:
#line 973 "CISA.y" /* yacc.c:1646  */
    {
        // a grammatically problematic instruction
        //   addr_add (M1_NM, 1) A0(0)<1> &V127 - 0x10...
        //                                        ^^^^ next operand or V127 offset
        pBuilder->CISA_create_address_instruction((yyvsp[-4].opcode), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3126 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 142:
#line 983 "CISA.y" /* yacc.c:1646  */
    {
        pBuilder->CISA_create_setp_instruction(
            (yyvsp[-3].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-1].vISADecl), (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3135 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 143:
#line 990 "CISA.y" /* yacc.c:1646  */
    {
        pBuilder->CISA_create_sel_instruction((yyvsp[-5].opcode), (yyvsp[-4].sat), (yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3144 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 144:
#line 997 "CISA.y" /* yacc.c:1646  */
    {
        pBuilder->CISA_create_fminmax_instruction(0, ISA_FMINMAX, (yyvsp[-4].sat), (yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3153 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 145:
#line 1005 "CISA.y" /* yacc.c:1646  */
    {
        pBuilder->CISA_create_fminmax_instruction(
            1, ISA_FMINMAX, (yyvsp[-4].sat), (yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3163 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 146:
#line 1014 "CISA.y" /* yacc.c:1646  */
    {
        pBuilder->CISA_create_mov_instruction(
            (yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-3].sat),
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3173 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 147:
#line 1021 "CISA.y" /* yacc.c:1646  */
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_mov_instruction((yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].vISADecl), CISAlineno));
    }
#line 3181 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 148:
#line 1027 "CISA.y" /* yacc.c:1646  */
    {
        pBuilder->CISA_create_movs_instruction((yyvsp[-2].emask_exec_size).emask, ISA_MOVS, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].StateVar).cisa_gen_opnd, (yyvsp[0].StateVar).cisa_gen_opnd, CISAlineno);
    }
#line 3190 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 149:
#line 1033 "CISA.y" /* yacc.c:1646  */
    {
        pBuilder->CISA_create_movs_instruction((yyvsp[-2].emask_exec_size).emask, ISA_MOVS, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].StateVar).cisa_gen_opnd, CISAlineno);
    }
#line 3199 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 150:
#line 1039 "CISA.y" /* yacc.c:1646  */
    {
        pBuilder->CISA_create_movs_instruction((yyvsp[-2].emask_exec_size).emask, ISA_MOVS, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].StateVar).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3208 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 151:
#line 1057 "CISA.y" /* yacc.c:1646  */
    {
        pBuilder->CISA_create_cmp_instruction((yyvsp[-4].cond_mod), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].vISADecl), (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3217 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 152:
#line 1064 "CISA.y" /* yacc.c:1646  */
    {
        // NOTE: predication not permitted.  Apparently the vISA API doesn't allow for predicated compares
        pBuilder->CISA_create_cmp_instruction(
            (yyvsp[-4].cond_mod), ISA_CMP, (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3228 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 153:
#line 1074 "CISA.y" /* yacc.c:1646  */
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_media_instruction(
            (yyvsp[-7].opcode), (yyvsp[-6].media_mode), (yyvsp[-5].offset).row, (yyvsp[-5].offset).elem, (int)(yyvsp[-3].intval), (yyvsp[-4].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 3238 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 154:
#line 1082 "CISA.y" /* yacc.c:1646  */
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_media_instruction(
            (yyvsp[-6].opcode), (yyvsp[-5].media_mode), (yyvsp[-4].offset).row, (yyvsp[-4].offset).elem, (int)0, (yyvsp[-3].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 3248 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 155:
#line 1088 "CISA.y" /* yacc.c:1646  */
    {
        MUST_HOLD((yyvsp[0].intval) <= 0xF, "PlaneID must less than 0xF");
        (yyval.intval) = (yyvsp[0].intval);
    }
#line 3257 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 156:
#line 1096 "CISA.y" /* yacc.c:1646  */
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_scatter_instruction(
            (yyvsp[-7].opcode), (int)(yyvsp[-6].intval), (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-4].oword_mod), (yyvsp[-3].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3267 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 157:
#line 1105 "CISA.y" /* yacc.c:1646  */
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_scatter4_typed_instruction(
            (yyvsp[-8].opcode), (yyvsp[-9].pred_reg), ChannelMask::createFromAPI((yyvsp[-7].s_channel)), (yyvsp[-6].emask_exec_size).emask, (yyvsp[-6].emask_exec_size).exec_size, (yyvsp[-5].string),
            (yyvsp[-4].RawVar), (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3277 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 158:
#line 1114 "CISA.y" /* yacc.c:1646  */
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_scatter4_scaled_instruction(
            (yyvsp[-6].opcode), (yyvsp[-7].pred_reg), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size, ChannelMask::createFromAPI((yyvsp[-5].s_channel)), (yyvsp[-3].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3287 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 159:
#line 1123 "CISA.y" /* yacc.c:1646  */
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_scatter_scaled_instruction(
            (yyvsp[-7].opcode), (yyvsp[-8].pred_reg), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size, (uint32_t) (yyvsp[-5].intval), (yyvsp[-3].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3297 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 160:
#line 1130 "CISA.y" /* yacc.c:1646  */
    {
        pBuilder->CISA_create_sync_instruction((yyvsp[0].opcode), CISAlineno);
    }
#line 3305 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 161:
#line 1133 "CISA.y" /* yacc.c:1646  */
    {
        pBuilder->CISA_create_sbarrier_instruction(true, CISAlineno);
    }
#line 3313 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 162:
#line 1136 "CISA.y" /* yacc.c:1646  */
    {
        pBuilder->CISA_create_sbarrier_instruction(false, CISAlineno);
    }
#line 3321 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 163:
#line 1142 "CISA.y" /* yacc.c:1646  */
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_dword_atomic_instruction(
            (yyvsp[-9].pred_reg), (yyvsp[-7].atomic_op), (yyvsp[-6].flag), (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-4].string), (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3330 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 164:
#line 1149 "CISA.y" /* yacc.c:1646  */
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_typed_atomic_instruction(
            (yyvsp[-12].pred_reg), (yyvsp[-10].atomic_op), (yyvsp[-9].flag), (yyvsp[-8].emask_exec_size).emask, (yyvsp[-8].emask_exec_size).exec_size, (yyvsp[-7].string),
            (yyvsp[-6].RawVar), (yyvsp[-5].RawVar), (yyvsp[-4].RawVar), (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3340 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 165:
#line 1156 "CISA.y" /* yacc.c:1646  */
    {(yyval.flag) = false;}
#line 3346 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 166:
#line 1157 "CISA.y" /* yacc.c:1646  */
    { // .16
        MUST_HOLD(((yyvsp[0].intval) == 16), "only supports 16");
        (yyval.flag) = true;
    }
#line 3355 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 167:
#line 1164 "CISA.y" /* yacc.c:1646  */
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_sampleunorm_instruction(
            (yyvsp[-9].opcode), ChannelMask::createFromAPI((yyvsp[-8].s_channel)), (yyvsp[-7].s_channel_output), (yyvsp[-6].string), (yyvsp[-5].string),
            (yyvsp[-4].genOperand).cisa_gen_opnd, (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 3365 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 168:
#line 1173 "CISA.y" /* yacc.c:1646  */
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_sample_instruction(
            (yyvsp[-8].opcode), ChannelMask::createFromAPI((yyvsp[-7].s_channel)), (int)(yyvsp[-6].intval), (yyvsp[-5].string), (yyvsp[-4].string),
            (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3375 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 169:
#line 1181 "CISA.y" /* yacc.c:1646  */
    {
       ABORT_ON_FAIL(pBuilder->CISA_create_sample_instruction(
           (yyvsp[-7].opcode), ChannelMask::createFromAPI((yyvsp[-6].s_channel)), (int)(yyvsp[-5].intval), "", (yyvsp[-4].string),
           (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
   }
#line 3385 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 170:
#line 1191 "CISA.y" /* yacc.c:1646  */
    {
       const bool success = pBuilder->create3DSampleInstruction(
           (yyvsp[-11].pred_reg), (yyvsp[-10].sample3DOp), (yyvsp[-9].pixel_null_mask), (yyvsp[-8].cps), (yyvsp[-7].non_uniform_sampler), ChannelMask::createFromAPI((yyvsp[-6].s_channel)),
           (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-4].genOperand).cisa_gen_opnd, (yyvsp[-3].string), (yyvsp[-2].string),
           (yyvsp[-1].RawVar), (unsigned int)(yyvsp[0].intval), rawOperandArray, CISAlineno);

    ABORT_ON_FAIL(success);
   }
#line 3398 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 171:
#line 1200 "CISA.y" /* yacc.c:1646  */
    {(yyval.cps) = false;}
#line 3404 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 172:
#line 1200 "CISA.y" /* yacc.c:1646  */
    {(yyval.cps) = true;}
#line 3410 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 173:
#line 1202 "CISA.y" /* yacc.c:1646  */
    {(yyval.non_uniform_sampler) = false;}
#line 3416 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 174:
#line 1202 "CISA.y" /* yacc.c:1646  */
    {(yyval.non_uniform_sampler) = true;}
#line 3422 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 175:
#line 1208 "CISA.y" /* yacc.c:1646  */
    {
       const bool success = pBuilder->create3DLoadInstruction(
           (yyvsp[-8].pred_reg), (yyvsp[-7].sample3DOp), (yyvsp[-6].pixel_null_mask), ChannelMask::createFromAPI((yyvsp[-5].s_channel)),
           (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size, (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].string),
           (yyvsp[-1].RawVar), (unsigned int)(yyvsp[0].intval), rawOperandArray, CISAlineno);

    ABORT_ON_FAIL(success);
   }
#line 3435 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 176:
#line 1221 "CISA.y" /* yacc.c:1646  */
    {
       const bool success = pBuilder->createSample4Instruction(
          (yyvsp[-9].pred_reg), (yyvsp[-8].sample3DOp), (yyvsp[-7].pixel_null_mask), ChannelMask::createFromAPI((yyvsp[-6].s_channel)), (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size,
          (yyvsp[-4].genOperand).cisa_gen_opnd, (yyvsp[-3].string), (yyvsp[-2].string),
          (yyvsp[-1].RawVar), (unsigned int)(yyvsp[0].intval), rawOperandArray, CISAlineno);

    ABORT_ON_FAIL(success);
   }
#line 3448 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 177:
#line 1230 "CISA.y" /* yacc.c:1646  */
    {(yyval.pixel_null_mask) = false;}
#line 3454 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 178:
#line 1230 "CISA.y" /* yacc.c:1646  */
    {(yyval.pixel_null_mask) = true;}
#line 3460 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 179:
#line 1234 "CISA.y" /* yacc.c:1646  */
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_info_3d_instruction(
            VISA_3D_RESINFO, (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            ChannelMask::createFromAPI((yyvsp[-4].s_channel)), (yyvsp[-2].string), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
   }
#line 3470 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 180:
#line 1242 "CISA.y" /* yacc.c:1646  */
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_info_3d_instruction(
            VISA_3D_SAMPLEINFO, (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            ChannelMask::createFromAPI((yyvsp[-3].s_channel)), (yyvsp[-1].string), NULL, (yyvsp[0].RawVar), CISAlineno));
   }
#line 3480 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 181:
#line 1250 "CISA.y" /* yacc.c:1646  */
    {
    }
#line 3487 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 182:
#line 1253 "CISA.y" /* yacc.c:1646  */
    {
        RTRWOperands.push_back((yyvsp[0].genOperand).cisa_gen_opnd);
    }
#line 3495 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 183:
#line 1257 "CISA.y" /* yacc.c:1646  */
    {
        RTRWOperands.push_back((yyvsp[0].RawVar));
    }
#line 3503 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 184:
#line 1262 "CISA.y" /* yacc.c:1646  */
    {
       bool result = pBuilder->CISA_create_rtwrite_3d_instruction(
           (yyvsp[-5].pred_reg), (yyvsp[-3].string), (yyvsp[-2].emask_exec_size).emask, (unsigned int)(yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-1].string),
           RTRWOperands, CISAlineno);
       RTRWOperands.clear();
       if (!result)
           YYABORT; // already reported
   }
#line 3516 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 185:
#line 1271 "CISA.y" /* yacc.c:1646  */
    {(yyval.string) = 0;}
#line 3522 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 187:
#line 1276 "CISA.y" /* yacc.c:1646  */
    {
        pBuilder->CISA_create_urb_write_3d_instruction(
            (yyvsp[-8].pred_reg), (yyvsp[-6].emask_exec_size).emask, (unsigned int)(yyvsp[-6].emask_exec_size).exec_size, (unsigned int)(yyvsp[-5].intval), (unsigned int)(yyvsp[-4].intval),
            (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 3532 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 188:
#line 1284 "CISA.y" /* yacc.c:1646  */
    {
        pBuilder->CISA_create_avs_instruction(
            ChannelMask::createFromAPI((yyvsp[-14].s_channel)), (yyvsp[-13].string), (yyvsp[-12].string),
            (yyvsp[-11].genOperand).cisa_gen_opnd, (yyvsp[-10].genOperand).cisa_gen_opnd, (yyvsp[-9].genOperand).cisa_gen_opnd, (yyvsp[-8].genOperand).cisa_gen_opnd,
            (yyvsp[-7].genOperand).cisa_gen_opnd, (yyvsp[-6].genOperand).cisa_gen_opnd, (yyvsp[-5].genOperand).cisa_gen_opnd, (yyvsp[-4].cntrl), (yyvsp[-3].genOperand).cisa_gen_opnd,
            (yyvsp[-2].execMode), (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno);
    }
#line 3544 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 189:
#line 1296 "CISA.y" /* yacc.c:1646  */
    {
       //     1 - OP
       //     2 - StreamMode, SearchCtrl
       //     3 - Surface
       //     4 - UNIInput
       //     5 - IMEInput
       //     6 - ref0
       //     7 - ref1
       //     8 - CostCenter
       //     9 - Output
        ABORT_ON_FAIL(pBuilder->CISA_create_vme_ime_instruction(
            (yyvsp[-8].opcode), (yyvsp[-7].vmeOpndIvb).streamMode, (yyvsp[-7].vmeOpndIvb).searchCtrl, (yyvsp[-5].RawVar), (yyvsp[-4].RawVar), (yyvsp[-6].string), (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
   }
#line 3562 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 190:
#line 1312 "CISA.y" /* yacc.c:1646  */
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_vme_sic_instruction((yyvsp[-4].opcode), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[-3].string), (yyvsp[0].RawVar), CISAlineno));
   }
#line 3570 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 191:
#line 1318 "CISA.y" /* yacc.c:1646  */
    {
        //    1 - OP
        //    2 - FBRMdMode, FBRSubMbShape, FBRSubPredMode
        //    3 - surface
        //    4 - UNIInput
        //    5 - FBRInput
        //    6 - output
        ABORT_ON_FAIL(pBuilder->CISA_create_vme_fbr_instruction((yyvsp[-5].opcode), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[-3].string),
            (yyvsp[-4].vmeOpndFbr).cisa_fbrMbMode_opnd, (yyvsp[-4].vmeOpndFbr).cisa_fbrSubMbShape_opnd, (yyvsp[-4].vmeOpndFbr).cisa_fbrSubPredMode_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 3585 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 192:
#line 1331 "CISA.y" /* yacc.c:1646  */
    {
        ABORT_ON_FAIL(
            pBuilder->CISA_create_oword_instruction((yyvsp[-5].opcode), (yyvsp[-4].oword_mod), (yyvsp[-3].emask_exec_size).exec_size, (yyvsp[-2].string), (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 3594 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 193:
#line 1339 "CISA.y" /* yacc.c:1646  */
    {
        bool aligned = false;
        pBuilder->CISA_create_svm_block_instruction((SVMSubOpcode)(yyvsp[-3].opcode), (yyvsp[-2].emask_exec_size).exec_size, aligned,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno);
    }
#line 3604 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 194:
#line 1346 "CISA.y" /* yacc.c:1646  */
    {
        pBuilder->CISA_create_svm_scatter_instruction((yyvsp[-8].pred_reg), (SVMSubOpcode)(yyvsp[-7].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (unsigned int)(yyvsp[-5].intval), (unsigned int)(yyvsp[-3].intval), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 3613 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 195:
#line 1352 "CISA.y" /* yacc.c:1646  */
    {
        pBuilder->CISA_create_svm_atomic_instruction((yyvsp[-8].pred_reg), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size, (yyvsp[-6].atomic_op), (unsigned short)(yyvsp[-5].intval),
            (yyvsp[-3].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), (yyvsp[-2].RawVar), CISAlineno);
    }
#line 3622 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 196:
#line 1358 "CISA.y" /* yacc.c:1646  */
    {
        pBuilder->CISA_create_svm_gather4_scaled((yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, ChannelMask::createFromAPI((yyvsp[-4].s_channel)),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 3631 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 197:
#line 1364 "CISA.y" /* yacc.c:1646  */
    {
        pBuilder->CISA_create_svm_scatter4_scaled((yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, ChannelMask::createFromAPI((yyvsp[-4].s_channel)),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 3640 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 198:
#line 1370 "CISA.y" /* yacc.c:1646  */
    {(yyval.intval) = 32;}
#line 3646 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 199:
#line 1371 "CISA.y" /* yacc.c:1646  */
    {
        MUST_HOLD((yyvsp[0].intval) == 16 || (yyvsp[0].intval) == 32 || (yyvsp[0].intval) == 64, "only supports 16 or 64");
        (yyval.intval) = (yyvsp[0].intval);
    }
#line 3655 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 200:
#line 1379 "CISA.y" /* yacc.c:1646  */
    {
    }
#line 3662 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 201:
#line 1382 "CISA.y" /* yacc.c:1646  */
    {
    }
#line 3669 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 202:
#line 1385 "CISA.y" /* yacc.c:1646  */
    {
        // parse rule means we see last label first
        switchLabels.push_front((yyvsp[-1].string));
    }
#line 3678 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 203:
#line 1392 "CISA.y" /* yacc.c:1646  */
    {
        pBuilder->CISA_create_branch_instruction((yyvsp[-3].pred_reg), (yyvsp[-2].opcode), (yyvsp[-1].emask_exec_size).emask, (yyvsp[-1].emask_exec_size).exec_size, (yyvsp[0].string), false, CISAlineno);
    }
#line 3686 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 204:
#line 1396 "CISA.y" /* yacc.c:1646  */
    {
        pBuilder->CISA_create_branch_instruction((yyvsp[-3].pred_reg), (yyvsp[-2].cisa_call).opcode, (yyvsp[-1].emask_exec_size).emask, (yyvsp[-1].emask_exec_size).exec_size, (yyvsp[0].string), (yyvsp[-2].cisa_call).is_fccall, CISAlineno);
    }
#line 3694 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 205:
#line 1400 "CISA.y" /* yacc.c:1646  */
    {
        pBuilder->CISA_Create_Ret((yyvsp[-2].pred_reg), (yyvsp[-1].opcode), (yyvsp[0].emask_exec_size).emask, (yyvsp[0].emask_exec_size).exec_size, CISAlineno);
    }
#line 3702 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 206:
#line 1404 "CISA.y" /* yacc.c:1646  */
    {
        pBuilder->CISA_create_switch_instruction((yyvsp[-5].opcode), (yyvsp[-4].emask_exec_size).exec_size, (yyvsp[-3].genOperand).cisa_gen_opnd, switchLabels, CISAlineno);
        switchLabels.clear();
    }
#line 3711 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 207:
#line 1410 "CISA.y" /* yacc.c:1646  */
    {
        pBuilder->CISA_create_fcall_instruction((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, (yyvsp[-2].string), (unsigned)(yyvsp[-1].intval), (unsigned)(yyvsp[0].intval), CISAlineno);
    }
#line 3719 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 208:
#line 1415 "CISA.y" /* yacc.c:1646  */
    {
        pBuilder->CISA_create_ifcall_instruction(
        (yyvsp[-5].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
        (yyvsp[-2].genOperand).cisa_gen_opnd, (unsigned)(yyvsp[-1].intval), (unsigned)(yyvsp[0].intval), CISAlineno);
    }
#line 3729 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 209:
#line 1422 "CISA.y" /* yacc.c:1646  */
    {
        pBuilder->CISA_create_faddr_instruction((yyvsp[-1].string), (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3737 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 210:
#line 1427 "CISA.y" /* yacc.c:1646  */
    {
        pBuilder->CISA_create_FILE_instruction((yyvsp[-1].opcode), (yyvsp[0].string), CISAlineno);
    }
#line 3745 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 211:
#line 1432 "CISA.y" /* yacc.c:1646  */
    {
        pBuilder->CISA_create_LOC_instruction((yyvsp[-1].opcode), (unsigned)(yyvsp[0].intval), CISAlineno);
    }
#line 3753 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 212:
#line 1438 "CISA.y" /* yacc.c:1646  */
    {
        pBuilder->CISA_create_raw_send_instruction(ISA_RAW_SEND, false, (yyvsp[-6].emask_exec_size).emask, (yyvsp[-6].emask_exec_size).exec_size, (yyvsp[-8].pred_reg),
            (unsigned)(yyvsp[-5].intval), (unsigned char)(yyvsp[-4].intval), (unsigned char)(yyvsp[-3].intval), (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 3762 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 213:
#line 1445 "CISA.y" /* yacc.c:1646  */
    {
        pBuilder->CISA_create_raw_send_instruction(ISA_RAW_SEND, true, (yyvsp[-6].emask_exec_size).emask, (yyvsp[-6].emask_exec_size).exec_size, (yyvsp[-8].pred_reg),
            (unsigned)(yyvsp[-5].intval), (unsigned char)(yyvsp[-4].intval), (unsigned char)(yyvsp[-3].intval), (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 3771 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 214:
#line 1452 "CISA.y" /* yacc.c:1646  */
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_lifetime_inst((unsigned char)0, (yyvsp[0].string), CISAlineno));
    }
#line 3779 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 215:
#line 1458 "CISA.y" /* yacc.c:1646  */
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_lifetime_inst((unsigned char)1, (yyvsp[0].string), CISAlineno));
    }
#line 3787 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 216:
#line 1464 "CISA.y" /* yacc.c:1646  */
    {
        pBuilder->CISA_create_raw_sends_instruction(
            ISA_RAW_SENDS, false, false, (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-11].pred_reg), (yyvsp[-4].genOperand).cisa_gen_opnd,
            (unsigned char)(yyvsp[-9].intval), (unsigned char)(yyvsp[-8].intval), (unsigned char)(yyvsp[-7].intval), (unsigned char)(yyvsp[-6].intval),
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 3798 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 217:
#line 1472 "CISA.y" /* yacc.c:1646  */
    {
        pBuilder->CISA_create_raw_sends_instruction(
            ISA_RAW_SENDS, false, true, (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-11].pred_reg), (yyvsp[-4].genOperand).cisa_gen_opnd,
            (unsigned char)(yyvsp[-9].intval), (unsigned char)(yyvsp[-8].intval), (unsigned char)(yyvsp[-7].intval), (unsigned char)(yyvsp[-6].intval),
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 3809 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 218:
#line 1480 "CISA.y" /* yacc.c:1646  */
    {
        pBuilder->CISA_create_raw_sends_instruction(
            ISA_RAW_SENDS, true, false, (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-10].pred_reg), (yyvsp[-4].genOperand).cisa_gen_opnd,
            0, (unsigned char)(yyvsp[-8].intval), (unsigned char)(yyvsp[-7].intval), (unsigned char)(yyvsp[-6].intval),
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 3820 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 219:
#line 1488 "CISA.y" /* yacc.c:1646  */
    {
        pBuilder->CISA_create_raw_sends_instruction(
            ISA_RAW_SENDS, true, true, (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-10].pred_reg), (yyvsp[-4].genOperand).cisa_gen_opnd,
            0, (unsigned char)(yyvsp[-8].intval), (unsigned char)(yyvsp[-7].intval), (unsigned char)(yyvsp[-6].intval),
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 3831 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 220:
#line 1497 "CISA.y" /* yacc.c:1646  */
    {
        pBuilder->CISA_create_NO_OPND_instruction((yyvsp[0].opcode), CISAlineno);
    }
#line 3839 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 221:
#line 1502 "CISA.y" /* yacc.c:1646  */
    {
        pBuilder->CISA_create_wait_instruction((yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3847 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 222:
#line 1507 "CISA.y" /* yacc.c:1646  */
    {
        pBuilder->CISA_create_yield_instruction((yyvsp[0].opcode), CISAlineno);
    }
#line 3855 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 223:
#line 1512 "CISA.y" /* yacc.c:1646  */
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[0].opcode), 0x0, CISAlineno);
    }
#line 3863 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 224:
#line 1517 "CISA.y" /* yacc.c:1646  */
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[-1].opcode), (yyvsp[0].fence_options), CISAlineno);
    }
#line 3871 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 225:
#line 1522 "CISA.y" /* yacc.c:1646  */
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[0].opcode), 0x20, CISAlineno);
    }
#line 3879 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 226:
#line 1527 "CISA.y" /* yacc.c:1646  */
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[-1].opcode), (yyvsp[0].fence_options) | 0x20, CISAlineno);
    }
#line 3887 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 227:
#line 1532 "CISA.y" /* yacc.c:1646  */
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[0].opcode), 0x80, CISAlineno);
    }
#line 3895 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 228:
#line 1536 "CISA.y" /* yacc.c:1646  */
    {(yyval.oword_mod) = false;}
#line 3901 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 230:
#line 1543 "CISA.y" /* yacc.c:1646  */
    {
        (yyval.pred_reg) = NULL;
    }
#line 3909 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 231:
#line 1548 "CISA.y" /* yacc.c:1646  */
    {
        (yyval.pred_reg) = pBuilder->CISA_create_predicate_operand((yyvsp[-2].vISADecl), (yyvsp[-3].pred_sign), (yyvsp[-1].pred_ctrl), CISAlineno);
    }
#line 3917 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 232:
#line 1552 "CISA.y" /* yacc.c:1646  */
    {(yyval.pred_sign) = PredState_NO_INVERSE;}
#line 3923 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 233:
#line 1552 "CISA.y" /* yacc.c:1646  */
    {(yyval.pred_sign) = PredState_INVERSE;}
#line 3929 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 234:
#line 1554 "CISA.y" /* yacc.c:1646  */
    {(yyval.pred_ctrl) = PRED_CTRL_NON;}
#line 3935 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 236:
#line 1557 "CISA.y" /* yacc.c:1646  */
    {(yyval.sat) = false;}
#line 3941 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 237:
#line 1557 "CISA.y" /* yacc.c:1646  */
    {(yyval.sat) = true;}
#line 3947 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 238:
#line 1560 "CISA.y" /* yacc.c:1646  */
    {(yyval.src_mod).mod = MODIFIER_NEG;}
#line 3953 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 239:
#line 1561 "CISA.y" /* yacc.c:1646  */
    {(yyval.src_mod).mod = MODIFIER_ABS;}
#line 3959 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 240:
#line 1562 "CISA.y" /* yacc.c:1646  */
    {(yyval.src_mod).mod = MODIFIER_NEG_ABS;}
#line 3965 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 241:
#line 1563 "CISA.y" /* yacc.c:1646  */
    {(yyval.src_mod).mod = MODIFIER_NOT;}
#line 3971 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 242:
#line 1565 "CISA.y" /* yacc.c:1646  */
    {(yyval.cond_mod) = ISA_CMP_UNDEF;}
#line 3977 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 244:
#line 1570 "CISA.y" /* yacc.c:1646  */
    {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESS;}
#line 3983 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 245:
#line 1571 "CISA.y" /* yacc.c:1646  */
    {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_GENERAL;}
#line 3989 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 246:
#line 1573 "CISA.y" /* yacc.c:1646  */
    {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_GENERAL;}
#line 3995 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 247:
#line 1574 "CISA.y" /* yacc.c:1646  */
    {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_INDIRECT;}
#line 4001 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 249:
#line 1579 "CISA.y" /* yacc.c:1646  */
    {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESSOF;}
#line 4007 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 251:
#line 1583 "CISA.y" /* yacc.c:1646  */
    {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESS;}
#line 4013 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 253:
#line 1587 "CISA.y" /* yacc.c:1646  */
    {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_INDIRECT;}
#line 4019 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 254:
#line 1588 "CISA.y" /* yacc.c:1646  */
    {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_IMMEDIATE;}
#line 4025 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 256:
#line 1592 "CISA.y" /* yacc.c:1646  */
    {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_IMMEDIATE;}
#line 4031 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 258:
#line 1596 "CISA.y" /* yacc.c:1646  */
    {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_IMMEDIATE;}
#line 4037 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 259:
#line 1597 "CISA.y" /* yacc.c:1646  */
    {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESSOF;}
#line 4043 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 261:
#line 1601 "CISA.y" /* yacc.c:1646  */
    {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESS;}
#line 4049 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 263:
#line 1605 "CISA.y" /* yacc.c:1646  */
    {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESS;}
#line 4055 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 264:
#line 1607 "CISA.y" /* yacc.c:1646  */
    {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_GENERAL;}
#line 4061 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 265:
#line 1610 "CISA.y" /* yacc.c:1646  */
    {
        // simple vector operand with no modifier that has an
        // implicit src region = <1,1,0>
        (yyval.genOperand).type = OPERAND_GENERAL;
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_gen_src_operand(
            (yyvsp[-1].string), 1, 1, 0, (yyvsp[0].offset).row, (yyvsp[0].offset).elem, MODIFIER_NONE, CISAlineno));
    }
#line 4073 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 266:
#line 1620 "CISA.y" /* yacc.c:1646  */
    {
        (yyval.vmeOpndIvb).streamMode = (unsigned char)(yyvsp[-3].intval);
        (yyval.vmeOpndIvb).searchCtrl = (unsigned char)(yyvsp[-1].intval);
    }
#line 4082 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 267:
#line 1627 "CISA.y" /* yacc.c:1646  */
    {
        (yyval.vmeOpndFbr).cisa_fbrMbMode_opnd = (yyvsp[-5].genOperand).cisa_gen_opnd;
        (yyval.vmeOpndFbr).cisa_fbrSubMbShape_opnd = (yyvsp[-3].genOperand).cisa_gen_opnd;
        (yyval.vmeOpndFbr).cisa_fbrSubPredMode_opnd = (yyvsp[-1].genOperand).cisa_gen_opnd;
    }
#line 4092 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 268:
#line 1635 "CISA.y" /* yacc.c:1646  */
    {
        MUST_HOLD((yyvsp[-1].intval) < 0x100, "offset out of bounds");
        (yyval.StateVar).offset = (unsigned char)(yyvsp[-1].intval);
        ABORT_ON_FAIL((yyval.StateVar).cisa_gen_opnd = pBuilder->CISA_create_state_operand((yyvsp[-3].string), (unsigned char)(yyvsp[-1].intval), CISAlineno, false));
    }
#line 4102 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 269:
#line 1643 "CISA.y" /* yacc.c:1646  */
    {
        MUST_HOLD((yyvsp[-1].intval) < 0x100, "offset out of bounds");
        (yyval.StateVar).offset = (unsigned char)(yyvsp[-1].intval);
        ABORT_ON_FAIL((yyval.StateVar).cisa_gen_opnd = pBuilder->CISA_create_state_operand((yyvsp[-3].string), (unsigned char)(yyvsp[-1].intval), CISAlineno, true));
    }
#line 4112 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 271:
#line 1674 "CISA.y" /* yacc.c:1646  */
    {
        MUST_HOLD((yyvsp[0].intval) == 0, "%null must have 0 as offset");
        (yyval.RawVar) = pBuilder->CISA_create_RAW_NULL_operand(CISAlineno); // can't fail
    }
#line 4121 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 272:
#line 1681 "CISA.y" /* yacc.c:1646  */
    {
        ABORT_ON_FAIL((yyval.RawVar) = pBuilder->CISA_create_RAW_operand((yyvsp[-1].string), (unsigned short)(yyvsp[0].intval), CISAlineno));
    }
#line 4129 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 273:
#line 1692 "CISA.y" /* yacc.c:1646  */
    {
        MUST_HOLD((yyvsp[0].intval) <= 0x10000, "offset out of bounds");
        (yyval.intval) = (yyvsp[0].intval);
    }
#line 4138 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 274:
#line 1697 "CISA.y" /* yacc.c:1646  */
    {
        MUST_HOLD((yyvsp[-1].intval) <= 0x10000, "offset out of bounds");
        (yyval.intval) = (yyvsp[-1].intval);
    }
#line 4147 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 275:
#line 1705 "CISA.y" /* yacc.c:1646  */
    {
        (yyval.intval) = 0;
    }
#line 4155 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 276:
#line 1710 "CISA.y" /* yacc.c:1646  */
    {
        rawOperandArray[(yyvsp[-1].intval)++] = (VISA_RawOpnd*)(yyvsp[0].RawVar);
        (yyval.intval) = (yyvsp[-1].intval);
    }
#line 4164 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 277:
#line 1718 "CISA.y" /* yacc.c:1646  */
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
          pBuilder->CISA_set_address_operand(
            (yyvsp[0].regAccess).cisa_decl, (yyvsp[0].regAccess).elem, (yyvsp[0].regAccess).row, true, CISAlineno));
    }
#line 4174 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 278:
#line 1726 "CISA.y" /* yacc.c:1646  */
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_dst_general_operand(
            (yyvsp[-2].string), (yyvsp[-1].offset).row, (yyvsp[-1].offset).elem, (unsigned short)(yyvsp[0].intval), CISAlineno));
    }
#line 4183 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 279:
#line 1731 "CISA.y" /* yacc.c:1646  */
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_dst_general_operand(
            (yyvsp[-1].string), 0, 0, (unsigned short)(yyvsp[0].intval), CISAlineno));
    }
#line 4192 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 280:
#line 1737 "CISA.y" /* yacc.c:1646  */
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_indirect_dst(
            (yyvsp[-2].regAccess).cisa_decl, MODIFIER_NONE, (yyvsp[-2].regAccess).row, (yyvsp[-2].regAccess).elem, (yyvsp[-2].regAccess).immOff, (unsigned short)(yyvsp[-1].intval), (yyvsp[0].type), CISAlineno));
    }
#line 4201 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 281:
#line 1758 "CISA.y" /* yacc.c:1646  */
    {
         (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_set_address_expression((yyvsp[0].regAccess).cisa_decl, 0, CISAlineno);
    }
#line 4209 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 282:
#line 1762 "CISA.y" /* yacc.c:1646  */
    {
         MUST_HOLD((short)(yyvsp[-1].intval) == (yyvsp[-1].intval), "variable address offset is too large");
         (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_set_address_expression((yyvsp[-3].regAccess).cisa_decl, (short)(yyvsp[-1].intval), CISAlineno);
    }
#line 4218 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 283:
#line 1768 "CISA.y" /* yacc.c:1646  */
    {
        // Both GENERAL_VAR and SURFACE_VAR are addressable
        (yyval.regAccess).cisa_decl = pBuilder->CISA_find_decl((yyvsp[0].string));
        if ((yyval.regAccess).cisa_decl == nullptr)
            PARSE_ERROR("unbound variable");
        (yyval.regAccess).row = 0;
        (yyval.regAccess).elem = 0;
    }
#line 4231 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 284:
#line 1779 "CISA.y" /* yacc.c:1646  */
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_set_address_operand(
                (yyvsp[0].regAccess).cisa_decl, (yyvsp[0].regAccess).elem, (yyvsp[0].regAccess).row, false, CISAlineno));
    }
#line 4241 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 285:
#line 1787 "CISA.y" /* yacc.c:1646  */
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_create_gen_src_operand(
                (yyvsp[-2].string), (yyvsp[0].cisa_region).v_stride, (yyvsp[0].cisa_region).width, (yyvsp[0].cisa_region).h_stride, (yyvsp[-1].offset).row, (yyvsp[-1].offset).elem, MODIFIER_NONE, CISAlineno));
    }
#line 4251 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 286:
#line 1794 "CISA.y" /* yacc.c:1646  */
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_create_gen_src_operand(
                (yyvsp[-2].string), (yyvsp[0].cisa_region).v_stride, (yyvsp[0].cisa_region).width, (yyvsp[0].cisa_region).h_stride, (yyvsp[-1].offset).row, (yyvsp[-1].offset).elem, (yyvsp[-3].src_mod).mod, CISAlineno));
    }
#line 4261 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 287:
#line 1804 "CISA.y" /* yacc.c:1646  */
    {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_immed((yyvsp[-1].intval), (yyvsp[0].type), CISAlineno);
    }
#line 4269 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 288:
#line 1809 "CISA.y" /* yacc.c:1646  */
    {
        MUST_HOLD((yyvsp[-1].intval) < 0x10000, "literal too large for half float");
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_immed(
            (unsigned short)(yyvsp[-1].intval), ISA_TYPE_HF, CISAlineno);
    }
#line 4279 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 289:
#line 1817 "CISA.y" /* yacc.c:1646  */
    {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_float_immed((yyvsp[0].fltval), ISA_TYPE_F, CISAlineno);
    }
#line 4287 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 290:
#line 1820 "CISA.y" /* yacc.c:1646  */
    {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_float_immed(-(yyvsp[0].fltval), ISA_TYPE_F, CISAlineno);
    }
#line 4295 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 291:
#line 1826 "CISA.y" /* yacc.c:1646  */
    {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_float_immed((yyvsp[0].fltval), ISA_TYPE_DF, CISAlineno);
    }
#line 4303 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 292:
#line 1830 "CISA.y" /* yacc.c:1646  */
    {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_float_immed(-(yyvsp[0].fltval), ISA_TYPE_DF, CISAlineno);
    }
#line 4311 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 294:
#line 1837 "CISA.y" /* yacc.c:1646  */
    {
        // "1:f" means 1.4e-45
        int number = (int)(yyvsp[-1].intval);
        float *fp = (float *)&number;
        (yyval.fltval) = *fp;
   }
#line 4322 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 295:
#line 1844 "CISA.y" /* yacc.c:1646  */
    {
        int number = (int)(yyvsp[-1].intval);
        float *fp = (float *)&number;
        (yyval.fltval) = *fp;
   }
#line 4332 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 297:
#line 1852 "CISA.y" /* yacc.c:1646  */
    {
        // "1:df" means 5e-324
        int64_t number = (yyvsp[-1].intval);
        double *fp = (double *)&number;
        (yyval.fltval) = *fp;
   }
#line 4343 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 298:
#line 1858 "CISA.y" /* yacc.c:1646  */
    {
        // to support 0x7ff0000000000000:df
        int64_t number = (yyvsp[-1].intval);
        double *fp = (double *)&number;
        (yyval.fltval) = *fp;
   }
#line 4354 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 299:
#line 1869 "CISA.y" /* yacc.c:1646  */
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_create_indirect(
                (yyvsp[-2].regAccess).cisa_decl, MODIFIER_NONE, (yyvsp[-2].regAccess).row, (yyvsp[-2].regAccess).elem, (yyvsp[-2].regAccess).immOff,
                (yyvsp[-1].cisa_region).v_stride, (yyvsp[-1].cisa_region).width, (yyvsp[-1].cisa_region).h_stride, (yyvsp[0].type), CISAlineno));
    }
#line 4365 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 300:
#line 1877 "CISA.y" /* yacc.c:1646  */
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_create_indirect(
                (yyvsp[-2].regAccess).cisa_decl, (yyvsp[-3].src_mod).mod, (yyvsp[-2].regAccess).row, (yyvsp[-2].regAccess).elem, (yyvsp[-2].regAccess).immOff,
                (yyvsp[-1].cisa_region).v_stride, (yyvsp[-1].cisa_region).width, (yyvsp[-1].cisa_region).h_stride, (yyvsp[0].type), CISAlineno));
    }
#line 4376 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 301:
#line 1886 "CISA.y" /* yacc.c:1646  */
    {
        MUST_HOLD(((yyvsp[-1].intval) == 0 || (yyvsp[-1].intval) == 1 || (yyvsp[-1].intval) == 2 || (yyvsp[-1].intval) == 4),
             "Dst HorzStride must be 0, 1, 2, or 4");
        (yyval.intval) = (yyvsp[-1].intval);
    }
#line 4386 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 302:
#line 1904 "CISA.y" /* yacc.c:1646  */
    {
        MUST_HOLD(((yyvsp[-5].intval) == 0 || (yyvsp[-5].intval) == 1 || (yyvsp[-5].intval) == 2 || (yyvsp[-5].intval) == 4 || (yyvsp[-5].intval) == 8 || (yyvsp[-5].intval) == 16 || (yyvsp[-5].intval) == 32),
                 "Src Region VertStride must be 0, 1, 2, 4, 8, 16, or 32");
        MUST_HOLD(((yyvsp[-3].intval) == 0 || (yyvsp[-3].intval) == 1 || (yyvsp[-3].intval) == 2 || (yyvsp[-3].intval) == 4 || (yyvsp[-3].intval) == 8 || (yyvsp[-3].intval) == 16),
                 "Src Region Width must be 0, 1, 2, 4, 8 or 16");
        MUST_HOLD(((yyvsp[-1].intval) == 0 || (yyvsp[-1].intval) == 1 || (yyvsp[-1].intval) == 2 || (yyvsp[-1].intval) == 4),
                 "Src Region HorzStride must be 0, 1, 2, or 4");
        (yyval.cisa_region).v_stride = (unsigned)(yyvsp[-5].intval);
        (yyval.cisa_region).width = (unsigned)(yyvsp[-3].intval);
        (yyval.cisa_region).h_stride = (unsigned)(yyvsp[-1].intval);
    }
#line 4402 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 304:
#line 1921 "CISA.y" /* yacc.c:1646  */
    {
        MUST_HOLD(((yyvsp[-3].intval) == 0 || (yyvsp[-3].intval) == 1 || (yyvsp[-3].intval) == 2 || (yyvsp[-3].intval) == 4 || (yyvsp[-3].intval) == 8 || (yyvsp[-3].intval) == 16),
                 "Width must be 0, 1, 2, 4, 8 or 16");
        MUST_HOLD(((yyvsp[-1].intval) == 0 || (yyvsp[-1].intval) == 1 || (yyvsp[-1].intval) == 2 || (yyvsp[-1].intval) == 4),
                 "HorzStride must be 0, 1, 2, or 4");
        (yyval.cisa_region).v_stride = -1;
        (yyval.cisa_region).width = (unsigned)(yyvsp[-3].intval);
        (yyval.cisa_region).h_stride = (unsigned)(yyvsp[-1].intval);
    }
#line 4416 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 305:
#line 1932 "CISA.y" /* yacc.c:1646  */
    {
        MUST_HOLD(((yyvsp[-1].intval) == 0 || (yyvsp[-1].intval) == 1 || (yyvsp[-1].intval) == 2 || (yyvsp[-1].intval) == 4),
             "HorzStride must be 0, 1, 2, or 4");
        (yyval.cisa_region).v_stride = -1;
        (yyval.cisa_region).width = -1;
        (yyval.cisa_region).h_stride = (unsigned)(yyvsp[-1].intval);
    }
#line 4428 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 306:
#line 1942 "CISA.y" /* yacc.c:1646  */
    {
        (yyval.regAccess) = (yyvsp[-3].regAccess);
        (yyval.regAccess).immOff = (int)(yyvsp[-1].intval);
    }
#line 4437 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 307:
#line 1947 "CISA.y" /* yacc.c:1646  */
    {
          (yyval.regAccess) = (yyvsp[-1].regAccess);
          (yyval.regAccess).immOff = 0;
    }
#line 4446 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 308:
#line 1952 "CISA.y" /* yacc.c:1646  */
    {
        MUST_HOLD((yyvsp[-3].intval) >= 0, "row (register) offset must be positive");
        (yyval.offset).row = (int)(yyvsp[-3].intval);
        MUST_HOLD((yyvsp[-1].intval) >= 0 && (yyvsp[-1].intval) <= 0xFFFF, "sub-register offset out of bounds");
        (yyval.offset).elem = (int)(yyvsp[-1].intval);
    }
#line 4457 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 309:
#line 1960 "CISA.y" /* yacc.c:1646  */
    {
        (yyval.vISADecl) = pBuilder->CISA_find_decl((yyvsp[0].string));
        if ((yyval.vISADecl) == nullptr)
            PARSE_ERROR((yyvsp[0].string), ": undefined predicate variable");
        if ((yyval.vISADecl)->type != PREDICATE_VAR)
            PARSE_ERROR((yyvsp[0].string), ": not a predicate variable");
    }
#line 4469 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 310:
#line 1969 "CISA.y" /* yacc.c:1646  */
    {
        (yyval.regAccess).cisa_decl = pBuilder->CISA_find_decl((yyvsp[-3].string));
        if ((yyval.regAccess).cisa_decl == nullptr) {
            PARSE_ERROR((yyvsp[-3].string), ": unbound variable");
        } else if ((yyval.regAccess).cisa_decl->type != ADDRESS_VAR) {
            PARSE_ERROR((yyvsp[-3].string), ": not an address variable");
        }
        (yyval.regAccess).row = 1;
        (yyval.regAccess).elem = (int)(yyvsp[-1].intval);
    }
#line 4484 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 311:
#line 1981 "CISA.y" /* yacc.c:1646  */
    {
        (yyval.regAccess).cisa_decl = pBuilder->CISA_find_decl((yyvsp[-6].string));
        if ((yyval.regAccess).cisa_decl == nullptr) {
            PARSE_ERROR((yyvsp[-6].string), ": unbound variable");
        } else if ((yyval.regAccess).cisa_decl->type != ADDRESS_VAR) {
            PARSE_ERROR((yyvsp[-6].string), ": not an address variable");
        }
        (yyval.regAccess).row = (int)(yyvsp[-1].intval);
        (yyval.regAccess).elem = (int)(yyvsp[-4].intval);
    }
#line 4499 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 312:
#line 1995 "CISA.y" /* yacc.c:1646  */
    {(yyval.intval) = 0;}
#line 4505 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 313:
#line 1998 "CISA.y" /* yacc.c:1646  */
    {
       MUST_HOLD(((yyvsp[-1].intval) == 8 || (yyvsp[-1].intval) == 16 || (yyvsp[-1].intval) == 32),
                 "SIMD mode can only be 8, 16, or 32");
       (yyval.intval) = (yyvsp[-1].intval);
    }
#line 4515 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 314:
#line 2009 "CISA.y" /* yacc.c:1646  */
    {
        (yyval.intval) = (yyvsp[0].intval);
    }
#line 4523 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 315:
#line 2021 "CISA.y" /* yacc.c:1646  */
    {
        (yyval.emask_exec_size).emask = vISA_EMASK_M1;
        (yyval.emask_exec_size).exec_size = (int)(yyvsp[-1].intval);
    }
#line 4532 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 316:
#line 2027 "CISA.y" /* yacc.c:1646  */
    {
        if (!ParseEMask(pBuilder, (yyvsp[-3].string), (yyval.emask_exec_size).emask)) {
            PARSE_ERROR("invalid execution offset info");
        }
        (yyval.emask_exec_size).exec_size = (int)(yyvsp[-1].intval);
    }
#line 4543 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 317:
#line 2035 "CISA.y" /* yacc.c:1646  */
    {
        if ((yyvsp[0].intval) != 1 && (yyvsp[0].intval) != 2 && (yyvsp[0].intval) != 4 && (yyvsp[0].intval) != 8 && (yyvsp[0].intval) != 16 && (yyvsp[0].intval) != 32) {
            PARSE_ERROR("invalid execution size");
        }
        (yyval.intval) = (unsigned short)(yyvsp[0].intval);
    }
#line 4554 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 323:
#line 2049 "CISA.y" /* yacc.c:1646  */
    {(yyval.intval) = (yyvsp[-4].intval) ? (yyvsp[-2].intval) : (yyvsp[0].intval);}
#line 4560 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 325:
#line 2052 "CISA.y" /* yacc.c:1646  */
    {(yyval.intval) = (yyvsp[-2].intval) & (yyvsp[0].intval);}
#line 4566 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 327:
#line 2055 "CISA.y" /* yacc.c:1646  */
    {(yyval.intval) = (yyvsp[-2].intval) ^ (yyvsp[0].intval);}
#line 4572 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 329:
#line 2058 "CISA.y" /* yacc.c:1646  */
    {(yyval.intval) = (yyvsp[-2].intval) | (yyvsp[0].intval);}
#line 4578 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 331:
#line 2061 "CISA.y" /* yacc.c:1646  */
    {(yyval.intval) = (yyvsp[-2].intval) == (yyvsp[0].intval);}
#line 4584 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 332:
#line 2062 "CISA.y" /* yacc.c:1646  */
    {(yyval.intval) = (yyvsp[-2].intval) != (yyvsp[0].intval);}
#line 4590 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 334:
#line 2065 "CISA.y" /* yacc.c:1646  */
    {(yyval.intval) = (yyvsp[-2].intval) < (yyvsp[0].intval);}
#line 4596 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 335:
#line 2066 "CISA.y" /* yacc.c:1646  */
    {(yyval.intval) = (yyvsp[-2].intval) > (yyvsp[0].intval);}
#line 4602 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 336:
#line 2067 "CISA.y" /* yacc.c:1646  */
    {(yyval.intval) = (yyvsp[-2].intval) <= (yyvsp[0].intval);}
#line 4608 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 337:
#line 2068 "CISA.y" /* yacc.c:1646  */
    {(yyval.intval) = (yyvsp[-2].intval) >= (yyvsp[0].intval);}
#line 4614 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 340:
#line 2089 "CISA.y" /* yacc.c:1646  */
    {(yyval.intval) = (yyvsp[-2].intval) << (yyvsp[0].intval);}
#line 4620 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 341:
#line 2090 "CISA.y" /* yacc.c:1646  */
    {(yyval.intval) = (int64_t)(yyvsp[-2].intval) >> (int)(yyvsp[0].intval);}
#line 4626 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 342:
#line 2091 "CISA.y" /* yacc.c:1646  */
    {(yyval.intval) = (int64_t)((uint64_t)(yyvsp[-2].intval) >> (uint64_t)(yyvsp[0].intval));}
#line 4632 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 344:
#line 2094 "CISA.y" /* yacc.c:1646  */
    {(yyval.intval) = (yyvsp[-2].intval) + (yyvsp[0].intval);}
#line 4638 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 345:
#line 2095 "CISA.y" /* yacc.c:1646  */
    {(yyval.intval) = (yyvsp[-2].intval) - (yyvsp[0].intval);}
#line 4644 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 347:
#line 2098 "CISA.y" /* yacc.c:1646  */
    {(yyval.intval) = (yyvsp[-2].intval) * (yyvsp[0].intval);}
#line 4650 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 348:
#line 2099 "CISA.y" /* yacc.c:1646  */
    {
            if ((yyvsp[0].intval) == 0)
                PARSE_ERROR("division by 0");
            (yyval.intval) = (yyvsp[-2].intval) / (yyvsp[0].intval);
        }
#line 4660 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 349:
#line 2104 "CISA.y" /* yacc.c:1646  */
    {
            if ((yyvsp[0].intval) == 0)
                PARSE_ERROR("division by 0");
            (yyval.intval) = (yyvsp[-2].intval) % (yyvsp[0].intval);
        }
#line 4670 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 351:
#line 2111 "CISA.y" /* yacc.c:1646  */
    {(yyval.intval) = -(yyvsp[0].intval);}
#line 4676 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 352:
#line 2112 "CISA.y" /* yacc.c:1646  */
    {(yyval.intval) = ~(yyvsp[0].intval);}
#line 4682 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 353:
#line 2113 "CISA.y" /* yacc.c:1646  */
    {(yyval.intval) = !((yyvsp[0].intval));}
#line 4688 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 357:
#line 2121 "CISA.y" /* yacc.c:1646  */
    {(yyval.intval) = (yyvsp[-1].intval);}
#line 4694 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 358:
#line 2125 "CISA.y" /* yacc.c:1646  */
    {
        (yyval.intval) = 0;
        ABORT_ON_FAIL(pBuilder->CISA_eval_sizeof_decl(CISAlineno, (yyvsp[0].string), (yyval.intval)));
    }
#line 4703 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 359:
#line 2129 "CISA.y" /* yacc.c:1646  */
    {
        // TODO: %AlignOf(...), %Max(..)
        (yyval.intval) = 0;
        ABORT_ON_FAIL(pBuilder->CISA_eval_sizeof_decl(CISAlineno, (yyvsp[-1].string), (yyval.intval)));
    }
#line 4713 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;

  case 360:
#line 2135 "CISA.y" /* yacc.c:1646  */
    {
        // e.g. %DispatchSimdSize
        // N.B. %sizeof happens above
        (yyval.intval) = 0;
        ABORT_ON_FAIL(pBuilder->CISA_lookup_builtin_constant(CISAlineno, "%DispatchSimd", (yyval.intval)));
    }
#line 4724 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
    break;


#line 4728 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (pBuilder, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (pBuilder, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, pBuilder);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, pBuilder);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (pBuilder, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, pBuilder);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, pBuilder);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 2153 "CISA.y" /* yacc.c:1906  */

///////////////////////////////////////////////////////////////////////////////
//                                                                           //
//                        Utility Functions                                  //
//                                                                           //
///////////////////////////////////////////////////////////////////////////////

void CISAerror(CISA_IR_Builder* pBuilder, char const *s)
{
    pBuilder->RecordParseError(CISAlineno, s);
}

static bool ParseAlign(CISA_IR_Builder* pBuilder, const char *sym, VISA_Align &value)
{
    if (strcmp(sym, "byte") == 0) {
        value = ALIGN_BYTE;
    } else if (strcmp(sym, "word") == 0) {
        value = ALIGN_WORD;
    } else if (strcmp(sym, "dword") == 0) {
        value = ALIGN_DWORD;
    } else if (strcmp(sym, "qword") == 0) {
        value = ALIGN_QWORD;
    } else if (strcmp(sym, "oword") == 0) {
        value = ALIGN_OWORD;
    } else if (strcmp(sym, "GRF") == 0) {
        value = ALIGN_GRF;
    } else if (strcmp(sym, "GRFx2") == 0 || strcmp(sym, "2GRF") == 0) {
        value = ALIGN_2_GRF;
    } else if (strcmp(sym, "hword") == 0) {
        value = ALIGN_HWORD;
    } else if (strcmp(sym, "wordx32") == 0) {
        value = ALIGN_32WORD;
    } else if (strcmp(sym, "wordx64") == 0) {
        value = ALIGN_64WORD;
    } else {
        value = ALIGN_UNDEF;
        return false;
    }
    return true;
}


static VISA_Align AlignBytesToVisaAlignment(int bytes)
{
    VISA_Align val = ALIGN_UNDEF;
    switch (bytes) {
    case 1:   val = ALIGN_BYTE; break;
    case 2:   val = ALIGN_WORD; break;
    case 4:   val = ALIGN_DWORD; break;
    case 8:   val = ALIGN_QWORD; break;
    case 16:  val = ALIGN_OWORD; break;
    case 32:  val = ALIGN_HWORD; break;
    case 64:  val = ALIGN_32WORD; break;
    case 128: val = ALIGN_64WORD; break;
    default:  val = ALIGN_UNDEF; break;
    }
    return val;
}



static bool ParseEMask(
    CISA_IR_Builder* pBuilder,
    const char* sym,
    VISA_EMask_Ctrl &emask)
{
    if (strcmp(sym, "NoMask") == 0) {
        emask = vISA_EMASK_M1_NM;
        return true;
    }
    for (int i = 0; i < vISA_NUM_EMASK +1; i++)
    {
        if (!strcmp(emask_str[i], sym))
        {
            emask = (VISA_EMask_Ctrl)i;
            return true;
        }
    }

    emask = vISA_NUM_EMASK;
    return false;
}

